# RH 2.2.4-20, SuSE 2.3.1-32

# <epoch>:<version>-<release> tags for glibc main package
%define glibcversion	2.20
%define __glibcrelease	22
%define glibcepoch	6

# CVS snapshots of glibc
%define RELEASE		1
%if %{RELEASE}
%define source_package	glibc-%{glibcversion}
%define source_dir	glibc-%{glibcversion}
%define _glibcrelease	%{__glibcrelease}
%else
%define snapshot	20081113
%define source_package	glibc-%{glibcversion}-%{snapshot}
%define source_dir	glibc-%{glibcversion}
%define _glibcrelease	0.%{snapshot}.%{__glibcrelease}
%endif

%define glibcrelease	%mkrel %{_glibcrelease}

# crypt blowfish support
%define crypt_bf_ver	1.2

# Define "cross" to an architecture to which glibc is to be
# cross-compiled
%define build_cross		0
%{expand: %{?cross:		%%global build_cross 1}}

%if %{build_cross}
%define target_cpu	%{cross}
%define cross_prefix	cross-%{target_cpu}-
%define _prefix		/usr/%{target_cpu}-%{_real_vendor}-linux%{gnuext}
%define cross_program_prefix	%{target_cpu}-%{_real_vendor}-linux%{gnuext}-
%define _exec_prefix	%{_prefix}
# brain damage alert: should not be needed imho
# overriding _prefix and _exec_prefix should be enough
%define _bindir		%{_exec_prefix}/bin
%define _sbindir	%{_exec_prefix}/sbin
%define _libexecdir	%{_exec_prefix}/libexec
%define _datadir	%{_prefix}/share
%define _sharedstatedir	%{_prefix}/com
%define _localstatedir	%{_prefix}/var
%define _lib		lib
%define _libdir		%{_exec_prefix}/%{_lib}
%define _slibdir	%{_exec_prefix}/%{_lib}
%define _slibdir32	%{_exec_prefix}/lib
%define _includedir	%{_prefix}/include
%else
%define gnuext		%{_gnu}
%define target_cpu	%{_target_cpu}
%define cross_prefix	%{nil}
%define cross_program_prefix	%{nil}
%define _slibdir	/%{_lib}
%define _slibdir32	/lib
%endif

# Define target (base) architecture
%define arch		%(echo %{target_cpu}|sed -e "s/\\(i.86\\|athlon\\)/i386/" -e "s/amd64/x86_64/")
%define isarch()	%(case " %* " in (*" %{arch} "*) echo 1;; (*) echo 0;; esac)

%if %{build_cross}
%if %isarch %arm
%define gnuext          -gnueabi
%else
%define gnuext          -gnu
%endif
%endif

# Define Xen arches to build with -mno-tls-direct-direct-seg-refs
%define xenarches	%{ix86} x86_64

# arches which requires glibc-port
%define ports_arch	%arm %mips

# Define to build nscd with selinux support
%define build_selinux	0

# Flag for build_pdf_doc:
# 1	build glibc with PDF documentation
# 0	don't build PDF glibc documentation (e.g. for bootstrap build)
%define build_pdf_doc	0

# Enable checking by default for arches where we know tests all pass
%define build_check	0

# Allow make check to fail only when running kernels where we know
# tests must pass (no missing features or bugs in the kernel)
%define check_min_kver 2.6.32

# Define to build a biarch package
%define build_biarch	0
%if %isarch x86_64 mips64 mips64el
%define build_biarch	1
%endif

# Define to build glibc-debug package
%define build_debug	1
%define _enable_debug_packages 1
%if "%{_enable_debug_packages}" == "1"
%define build_debug	0
%endif

# Define to bootstrap new glibc
%define build_bootstrap	0
%{expand: %{!?build_cross_bootstrap: %global build_cross_bootstrap 0}}

%define build_profile	1
%define build_nscd	1
%define build_doc	1
%define build_utils	1
%define build_i18ndata	1
%define build_timezone	0

# Disable a few defaults when cross-compiling a glibc
%if %{build_cross}
%define build_doc	0
%define build_pdf_doc	0
%define build_biarch	0
%define build_check	0
%define build_debug	0
%define build_nscd	0
%define build_profile	0
%define build_utils	0
%define build_i18ndata	0
%define build_timezone	0
%endif

# Allow --with[out] <feature> at rpm command line build
%{expand: %{?_without_PDF:	%%global build_pdf_doc 0}}
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_without_UTILS:	%%global build_utils 0}}
%{expand: %{?_without_BOOTSTRAP:%%global build_bootstrap 0}}
%{expand: %{?_with_PDF:		%%global build_pdf_doc 1}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}
%{expand: %{?_with_UTILS:	%%global build_utils 1}}
%{expand: %{?_with_BOOTSTRAP:	%%global build_bootstrap 1}}

Summary:	The GNU libc libraries
Name:		%{cross_prefix}glibc
Version:	%{glibcversion}
Release:	%{glibcrelease}
Epoch:		%{glibcepoch}
License:	LGPL
Group:		System/Libraries
Url:		http://www.gnu.org/software/libc/

# FSF source
Source0:	http://ftp.gnu.org/gnu/glibc/%{source_package}.tar.xz
%if %{RELEASE}
Source1:	http://ftp.gnu.org/gnu/glibc/%{source_package}.tar.xz.sig
%endif
Source2:	libc-lock.h

Source4:	glibc-find-requires.sh
Source5:	glibc-check.sh
Source6:	nscd.service
Source7:	nscd.socket
Source8:	nsswitch.conf
Source9:	nscd.conf

# wrapper to avoid rpm circular dependencies
Source14:	glibc-post-wrapper.c

# Blowfish support
Source16:	http://www.openwall.com/crypt/crypt_blowfish-%{crypt_bf_ver}.tar.gz
Source17:	http://www.openwall.com/crypt/crypt_blowfish-%{crypt_bf_ver}.tar.gz.sign
Source18:	http://cvsweb.openwall.com/cgi/cvsweb.cgi/~checkout~/Owl/packages/glibc/crypt_freesec.c
Source19:	http://cvsweb.openwall.com/cgi/cvsweb.cgi/~checkout~/Owl/packages/glibc/crypt_freesec.h

%if %{build_cross}
Autoreq:	false
Autoprov:	false
%else
Provides:	glibc-crypt_blowfish = %{crypt_bf_ver}
Provides:	should-restart = system
%if %isarch %{xenarches}
Obsoletes:	%{name}-xen
Provides:	%{name}-xen
%endif
# The dynamic linker supports DT_GNU_HASH
Provides: rtld(GNU_HASH)
Autoreq:	false
%endif
BuildRequires:	patch
BuildRequires:	gettext
BuildRequires:	perl
BuildRequires:	kernel-userspace-headers
BuildRequires:	libstdc++-static-devel
BuildRequires:	hardlink
%if %{build_selinux}
BuildRequires:	libselinux-devel >= 1.17.10
%endif
# (tmb) force latest binutils
BuildRequires:	%{cross_prefix}binutils >= 2.20
# we need the static dash
%define ash_bin		/usr/bin/dash.static
Requires(post):		dash-static
Requires:		filesystem >= 2.1.9-18
# (tmb) force fixed gcc-4.9.1-2
BuildRequires:	%{cross_prefix}gcc >= 4.9.1-2
%if !%{build_cross}
%ifarch mips mipsel
Provides:	ld.so.1
%endif
%endif

# Old prelink versions brakes the system with glibc 2.11
Conflicts:	prelink < 1:0.4.2-1.20091104.1

BuildRequires:	texinfo
BuildRequires:	texinfo-tex
%if %{build_pdf_doc}
BuildRequires:	texlive
%endif
%if %{build_utils}
BuildRequires:	gd-devel
%endif
BuildRequires:	autoconf2.5
BuildRequires:	libcap-devel
BuildRequires:	rpm-mageia-setup-build >= 1.147
BuildRequires:	spec-helper >= 0.31.2

# make "localedef --add-to-archive" to follow symlink
# safe to send ustream, need to be kept for locales
Patch00:	glibc-2.11.1-localedef-archive-follow-symlinks.patch

# various path fix, according to usrmove
Patch01:	glibc-2.17-fhs-usrmove.patch
Patch02:	glibc-2.9-ldd-non-exec.patch
# try to fallback on loading /lib/libnss_*.so.X.Y when the loading 
# of /lib/libnss_*.so.X failed. Should be dropped, IMHO.
Patch04:	glibc-2.17-nss-upgrade.patch

Patch06:	glibc-2.20-share-locale.patch
# use xvt instead of xterm in xtrace.sh
# cannot be pushed upstream as xvt is Ma* specific 
Patch09:	glibc-2.2.4-xterm-xvt.patch

# add transliteration for "COLON SIGN"
# ( used for the money of money of san salvador )
Patch11:	glibc-2.19-compat-EUR-currencies.patch

# fix the chkconfig header, should be sent upstream
Patch13:	glibc-2.3.3-nscd-enable.patch

# disable cache for hosts on nscd, as this is seen as insecure
# if the system relie on reverse dns for security
Patch14:	glibc-2.9-nscd-no-host-cache.patch

Patch17:	glibc-2.18-i386-hwcapinfo.patch

# add some new timezone for various cities
# Halifax, Montreal, Johannesburg 
# should be sent upstream ( I guess )
Patch23:	glibc-2.3.4-timezone.patch
Patch24:	glibc-2.10.1-biarch-cpp-defines.patch
Patch26:	glibc-2.17-nice_fix.patch

# fix a typo, safe to send upstream
Patch27:	glibc-2.20-ENOTTY-fr-translation.patch
Patch29:	glibc-2.3.5-biarch-utils.patch

# remove multiarch header, Ma* specific patch
# check if still needed or if the work was finished
Patch30:	glibc-2.17-multiarch.patch
Patch31:	glibc-2.20-i586-hptiming.patch

# do not use i686 optimised library if the processor do not support
# cmov ( some i686 cpu don't, from VIA iirc )
# shuld be sent upstream, IMHO
Patch32:	glibc-2.3.4-i586-if-no-cmov.patch

# translation fixes, need to be checked with some i18n team member
# should be safe to send upstream once checked
Patch33:	glibc-2.3.6-pt_BR-i18nfixes.patch
Patch35:	glibc-2.16.0-force-gb18030-for-zh_CN.patch

# disable parallel testsuite of rt on powerpc with SMT
Patch38:	glibc-2.18-testsuite-rt-notparallel.patch
# freesec crypt
Patch39:	glibc-2.17-mga-owl-crypt_freesec.patch
Patch40:	glibc-2.14.1-avx-relocate_fcrypt.patch
Patch41:	glibc-2.14.1-avx-increase_BF_FRAME.patch
Patch42:	glibc-2.20-mga-avx-owl-crypt.patch

# add support for sha256 and sha512 in crypt
# likely coming from owl
Patch43:	glibc-2.16.0-mga-wrapper_handle_sha.patch

# check for libcap, even if selinux is disabled
# should be sent upstream
Patch44:	glibc-2.19-dont-tie-libcap-with-selinux.patch

# change page size to 16k. mandatory for loongson
# but not necessary a good idea for other socs
Patch46:	glibc-2.20-mips_16k_page_size.patch

Patch50:	crypt_blowfish_arm.patch

### upstream glibc 2.20 branch fixes
Patch101:	101-Update-Russian-translation.patch
Patch102:	102-Add-new-Linux-3.16-constants-to-netinet-udp.h.patch
Patch103:	103-Handle-zero-prefix-length-in-getifaddrs-BZ-17371.patch
Patch104:	104-Revert-to-defining-__extern_inline-only-for-gcc-4.3-.patch
Patch105:	105-Fix-memory-leak-in-libio-wfileops.c-do_ftell_wide-BZ.patch
Patch106:	106-Fix-memory-leak-in-error-path-of-do_ftell_wide-BZ-17.patch
Patch107:	107-Update-French-translation.patch
Patch108:	108-BZ-17460-Fix-buffer-overrun-in-nscd-help.patch
Patch109:	109-MIPS-Avoid-a-dangling-vfork-GLIBC_2.0-reference.patch
Patch110:	110-AArch64-End-frame-record-chain-correctly.patch
Patch111:	111-CVE-2014-7817-wordexp-fails-to-honour-WRDE_NOCMD.patch
Patch112:	112-Make-__extern_always_inline-usable-on-clang-again.patch
Patch113:	113-CVE-2012-3406-Stack-overflow-in-vfprintf-BZ-16617.patch
Patch114:	114-CVE-2014-9402-Avoid-infinite-loop-in-nss_dns-getnetbyname-BZ-17630.patch
Patch115:	115-Move-findidx-nested-functions-to-top-level.patch
# CVE pending for this one
Patch116:	116-Fix-memory-handling-in-strxfrm_l-BZ-16009.patch
Patch117:	117-Use-AVX-unaligned-memcpy-only-if-AVX2-is-available.patch
Patch118:	118-CVE-2015-1472-wscanf-allocates-too-little-memory.patch
# CVE pending
Patch119:	119-Fix-BZ-17269-_IO_wstr_overflow-integer-overflow.patch
# CVE pending
Patch120:	120-Fix-read-past-end-of-pattern-in-fnmatch-bug-18032.patch
# CVE-2015-1781
Patch121:	121-glibc-2.20-CVE-2015-1781-resolv-nss_dns-dns-host.c-buffer-overf.patch
# CVE-2014-8121
Patch122:	122-CVE-2014-8121-Do-not-close-NSS-files-database-during.patch
# CVE-2015-8777
Patch123:	123-CVE-2015-8777-Always-enable-pointer-guard-BZ-18928.patch
# CVE-2015-8776
Patch124:	124-CVE-2015-8776-Fix-BZ-18985-out-of-range-data-to-strftime-causes-a-.patch
# CVE-2015-8778
Patch125:	125-CVE-2015-8778-Handle-overflow-in-__hcreate_r.patch
Patch126:	126-CVE-2015-8778-Improve-check-against-integer-wraparound-in-hcreate_.patch
# CVE-2015-8779
Patch127:	127-CVE-2015-8779-catopen-Multiple-unbounded-stack-allocations.patch
# CVE-2014-9761
Patch128:	128-CVE-2014-9761-Refactor-strtod-parsing-of-NaN-payloads.patch
Patch129:	129-CVE-2014-9761-Fix-nan-functions-handling-of-payload-strings-bug-16.patch
# CVE-2015-7547
Patch130:	130-CVE-2015-7547-getaddrinfo-stack-based-buffer-overflo.patch
# CVE-2016-3075
Patch131:	131-CVE-2016-3075-Stack-overflow-in-_nss_dns_getnetbynam.patch
# CVE-2016-1234
Patch132:	132-glob-Simplify-the-interface-for-the-GLOB_ALTDIRFUNC-.patch
Patch133:	133-CVE-2016-1234-glob-Do-not-copy-d_name-field-of-struc.patch
# CVE-2016-3706
Patch134:	134-CVE-2016-3706-getaddrinfo-stack-overflow-in-hostent-.patch

### upstream fixes from glibc master branch
Patch201:	glibc-2.20-malloc-additional-unlink-hardening-for-non-small-bin.patch
# disable elision as glibc breaks on intel microcode udate
Patch202:	glibc-2.20-disable-all-lock-elision-unless--enable-lock-elision-is-yes.patch
# upstream (BZ #12926)
Patch203:	glibc-2.20-Fix-infinite-loop-in-check_pf.patch
# upstream [BZ #15378]
Patch204:	glibc-2.20-elf-dl-load.c-open_path-Avoid-writing-to-env_path_list-when-none-of-search-dir-exists.patch


# Determine minium kernel versions
%define		enablekernel 2.6.32
Conflicts:	kernel < %{enablekernel}

# conflict nicrocode that breaks lock elision
Conflicts:	microcode < 0.20140913-2

# People changed location of rpm scripts...
%define rpmscripts	/usr/lib/rpm/%{_real_vendor}

# Don't try to explicitly provide GLIBC_PRIVATE versioned libraries
%define __find_provides	%{_builddir}/%{source_dir}/find_provides.sh
%define __find_requires %{_builddir}/%{source_dir}/find_requires.sh

%if !%{build_cross}
Obsoletes:	ld.so
Provides:	ld.so
%endif

Obsoletes:	ldconfig
Provides:	ldconfig = %{glibcepoch}:%{glibcversion}-%{glibcrelease} /sbin/ldconfig
# obsolete nss_db as it got merged again in 2.15
Obsoletes:	nss_db <= 2.2.3-0.pre1.9

%description
The glibc package contains standard libraries which are used by
multiple programs on the system. In order to save disk space and
memory, as well as to make upgrading easier, common system code is
kept in one place and shared between programs. This particular package
contains the most important sets of shared libraries: the standard C
library and the standard math library. Without these two libraries, a
Linux system will not function.  The glibc package also contains
national language (locale) support.

This package now also provides ldconfig which was package seperately in
the past. Ldconfig is a basic system program which determines run-time
link bindings between ld.so and shared libraries. Ldconfig scans a running
system and sets up the symbolic links that are used to load shared
libraries properly. It also creates a cache (/etc/ld.so.cache) which
speeds the loading of programs which use shared libraries.

%package devel
Summary:	Header and object files for development using standard C libraries
Group:		Development/C
Requires(post):	  info-install
Requires(preun):  info-install
Requires(post):   coreutils
Requires(postun): coreutils, awk
Obsoletes:	libc-debug, libc-headers, libc-devel, linuxthreads-devel, nptl-devel
%if !%{build_debug}
Obsoletes:	%{name}-debug < 6:2.3.2-15
%endif
Requires:	%{name} = %{glibcepoch}:%{glibcversion}-%{glibcrelease}
%if !%{build_cross}
Requires:	linux-userspace-headers
%endif
%if %{build_cross}
Autoreq:	false
Autoprov:	false
%else
Autoreq:	true
%endif
Provides:	glibc-crypt_blowfish-devel = %{crypt_bf_ver}

%description devel
The glibc-devel package contains the header and object files necessary
for developing programs which use the standard C libraries (which are
used by nearly all programs).  If you are developing programs which
will use the standard C libraries, your system needs to have these
standard header and object files available in order to create the
executables.

This package also includes the C header files for the Linux kernel.
The header files define structures and constants that are needed for
building most standard programs. The header files are also needed for
rebuilding the kernel.

Install glibc-devel if you are going to develop programs which will
use the standard C libraries.

%package static-devel
Summary:	Static libraries for GNU C library
Group:		Development/C
Requires:	%{name}-devel = %{glibcepoch}:%{glibcversion}-%{glibcrelease}

%description static-devel
The glibc-static-devel package contains the static libraries necessary
for developing programs which use the standard C libraries. Install
glibc-static-devel if you need to statically link your program or
library.

%package profile
Summary:	The GNU libc libraries, including support for gprof profiling
Group:		Development/C
Obsoletes:	libc-profile
Provides:	libc-profile = %{glibcversion}-%{glibcrelease}
Autoreq:	true

%description profile
The glibc-profile package includes the GNU libc libraries and support
for profiling using the gprof program.  Profiling is analyzing a
program's functions to see how much CPU time they use and determining
which functions are calling other functions during execution.  To use
gprof to profile a program, your program needs to use the GNU libc
libraries included in glibc-profile (instead of the standard GNU libc
libraries included in the glibc package).

If you are going to use the gprof program to profile a program, you'll
need to install the glibc-profile program.

%package -n nscd
Summary:	A Name Service Caching Daemon (nscd)
Group:		System/Servers
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
Autoreq:	true

%description -n nscd
Nscd caches name service lookups and can dramatically improve
performance with NIS+, and may help with DNS as well. Note that you
can't use nscd with 2.0 kernels because of bugs in the kernel-side
thread support. Unfortunately, nscd happens to hit these bugs
particularly hard.

Install nscd if you need a name service lookup caching daemon, and
you're not using a version 2.0 kernel.

%if %{build_debug}
%package	debug
Summary:	Shared standard C libraries with debugging information
Group:		System/Libraries
Requires:	%{name} = %{glibcepoch}:%{glibcversion}-%{glibcrelease}
Autoreq:	false

%description debug
The glibc-debug package contains shared standard C libraries with
debugging information. You need this only if you want to step into C
library routines during debugging.

To use these libraries, you need to add %{_libdir}/debug to your
LD_LIBRARY_PATH variable prior to starting the debugger.
%endif

%package utils
Summary:	Development utilities from GNU C library
Group:		Development/Other
Requires:	%{name} = %{glibcepoch}:%{glibcversion}-%{glibcrelease}

%description utils
The glibc-utils package contains memusage, a memory usage profiler,
mtrace, a memory leak tracer and xtrace, a function call tracer which
can be helpful during program debugging.

If unsure if you need this, don't install this package.

%if %{build_i18ndata}
%package i18ndata
Summary:	Database sources for 'locale'
Group:		System/Libraries

%description i18ndata
This package contains the data needed to build the locale data files
to use the internationalization features of the GNU libc.
%endif

%if %{build_timezone}
%package -n timezone
Summary:	Time zone descriptions
Group:		System/Base

%description -n timezone
These are configuration files that describe possible
time zones.
%endif

%package doc
Summary:	GNU C library documentation
Group:		Development/Other
BuildArch:	noarch

%description doc
The glibc-doc package contains documentation for the GNU C library in
info format.

%if %{build_pdf_doc}
%package doc-pdf
Summary:	GNU C library documentation
Group:		Development/Other
BuildArch:	noarch

%description doc-pdf
The glibc-doc-pdf package contains the printable documentation for the
GNU C library in PDF format.
%endif

%prep
%setup -q -n %{source_dir} -a 16

# upstream fixes from glibc 2.20 branch
%patch101 -p1 -b .p101
%patch102 -p1 -b .p102
%patch103 -p1 -b .p103
%patch104 -p1 -b .p104
%patch105 -p1 -b .p105
%patch106 -p1 -b .p106
%patch107 -p1 -b .p107
%patch108 -p1 -b .p108
%patch109 -p1 -b .p109
%patch110 -p1 -b .p110
%patch111 -p1 -b .p111
%patch112 -p1 -b .p112
%patch113 -p1 -b .p113
%patch114 -p1 -b .p114
%patch115 -p1 -b .p115
%patch116 -p1 -b .p116
%patch117 -p1 -b .p117
%patch118 -p1 -b .p118
%patch119 -p1 -b .p119
%patch120 -p1 -b .p120
%patch121 -p1 -b .p121
%patch122 -p1 -b .p122
%patch123 -p1 -b .p123
%patch124 -p1 -b .p124
%patch125 -p1 -b .p125
%patch126 -p1 -b .p126
%patch127 -p1 -b .p127
%patch128 -p1 -b .p128
%patch129 -p1 -b .p129
%patch130 -p1 -b .p130
%patch131 -p1 -b .p131
%patch132 -p1 -b .p132
%patch133 -p1 -b .p133
%patch134 -p1 -b .p134

# upstream fixes from glibc master branch
%patch201 -p1 -b .p201
%patch202 -p1 -b .p202
%patch203 -p1 -b .p203
%patch204 -p1 -b .p204

# other patches
%patch00 -p1 -b .localedef-archive-follow-symlinks
%patch01 -p1 -b .fhs
%patch02 -p1 -b .ldd-non-exec
%patch04 -p1 -b .nss-upgrade
%patch06 -p1 -b .share-locale
%patch09 -p1 -b .xterm-xvt
%patch11 -p1 -b .compat-EUR-currencies
%patch13 -p1 -b .nscd-enable
%patch14 -p1 -b .nscd-no-host-cache
%patch17 -p1 -b .i386-hwcapinfo
%patch23 -p1 -b .timezone
%patch24 -p1 -b .biarch-cpp-defines
%patch26 -p1 -b .nice-fix
%patch27 -p1 -b .ENOTTY-fr-translation
%patch29 -p1 -b .biarch-utils
%patch30 -p1 -b .multiarch-check
%patch31 -p1 -b .i586-hptiming
%patch32 -p1 -b .i586-if-no-cmov
%patch33 -p1 -b .pt_BR-i18nfixes
%patch35 -p1 -b .zh_CN-charset-fixes
%patch38 -p1 -b .testsuite-rt-notparallel
%patch44 -p1 -b .dont-tie-libcap-with-selinux
%patch46 -p1 -b .pagesize

# copy freesec source
cp %{_sourcedir}/crypt_freesec.[ch] crypt/
echo "Applying crypt_blowfish patch:"
%patch42 -p1 -b .mga-avx-owl-crypt
mv crypt/crypt.h crypt/gnu-crypt.h
cp -a crypt_blowfish-%{crypt_bf_ver}/*.[chS] crypt/

# FreeSec support for extended/new-style/BSDI hashes in crypt(3)
%patch39 -p1 -b .mga-owl-crypt_freesec
%patch40 -p1 -b .avx-relocate_fcrypt
%patch41 -p1 -b .avx-increase_BF_FRAME
# add sha256-crypt and sha512-crypt support to the Openwall wrapper
%patch43 -p1 -b .mga-wrapper_handle_sha
%patch50 -p1 -b .crypt_arm_asm

%if %{build_selinux}
# XXX kludge to build nscd with selinux support as it added -nostdinc
# so /usr/include/selinux is not found
ln -s %{_includedir}/selinux selinux
%endif

find . -type f -size 0 -o -name "*.orig" -exec rm -f {} \;

# \\(Anssi 03/2008\\) FIXME: use __provides_exclude
cat > find_provides.sh << EOF
#!/bin/sh
%{rpmscripts}/find-provides | grep -v GLIBC_PRIVATE
exit 0
EOF
chmod +x find_provides.sh

cat > find_requires.bootstrap.sh << EOF
/bin/sh %{SOURCE4} %{buildroot} %{_target_cpu} | grep -v "\(GLIBC_PRIVATE\|linux-gate\|linux-vdso\)"
exit 0
EOF
chmod +x find_requires.bootstrap.sh

# XXX: use better way later to avoid LD_LIBRARY_PATH issue
cat %{rpmscripts}/find-requires | sed '/.*LD_LIBRARY_PATH.*/d;' > find_requires
chmod +x find_requires
# \\(Anssi 03/2008\\) FIXME: use __requires_exclude
cat > find_requires.noprivate.sh << EOF
%{_builddir}/%{source_dir}/find_requires %{buildroot} %{_target_cpu} | \
	grep -v GLIBC_PRIVATE
exit 0
EOF
chmod +x find_requires.noprivate.sh

# FIXME: fix system rpm find-requires to use the prefix cross version
%if %{build_bootstrap} || "%{_target_cpu}" != "%{target_cpu}"
ln -s find_requires.bootstrap.sh find_requires.sh
%else
ln -s find_requires.noprivate.sh find_requires.sh
%endif

# Remove patch backups from files we ship in glibc packages
rm -f ChangeLog.[^0-9]*
rm -f localedata/locales/{???_??,??_??}.*
rm -f localedata/locales/[a-z_]*.*

%build
# Prepare test matrix in the next function
CheckList=$PWD/Check.list
rm -f $CheckList
touch $CheckList

#
# CompareKver <kernel version>
# function to compare the desired kernel version with running kernel
# version (package releases not taken into account in comparison). The
# function returns:
# -1 = <kernel version> is lesser than current running kernel
#  0 = <kernel version> is equal to the current running kernel
#  1 = <kernel version> is greater than current running kernel
#
function CompareKver() {
  v1=`echo $1 | sed 's/\.\?$/./'`
  v2=`uname -r | sed 's/[^.0-9].*//' | sed 's/\.\?$/./'`
  n=1
  s=0
  while true; do
    c1=`echo "$v1" | cut -d "." -f $n`
    c2=`echo "$v2" | cut -d "." -f $n`
    if [ -z "$c1" -a -z "$c2" ]; then
      break
    elif [ -z "$c1" ]; then
      s=-1
      break
    elif [ -z "$c2" ]; then
      s=1
      break
    elif [ "$c1" -gt "$c2" ]; then
      s=1
      break
    elif [ "$c2" -gt "$c1" ]; then
      s=-1
      break
    fi
    n=$((n + 1))
  done
  echo $s
}

#
# BuildGlibc <arch> [<extra_configure_options>+]
#
function BuildGlibc() {
  arch="$1"
  shift 1

  # PowerPC CPU add-on
  case $arch in
    cpu-addon,*)
      cpu=` echo "$arch" | sed -n "/.*,\([^,]*\),.*$/s//\1/p"`
      arch=`echo "$arch" | sed -n "/.*,.*,\([^,]*\)$/s//\1/p"`
      ;;
    *)
      cpu=$arch
      ;;
  esac

  # Select optimization flags and compiler to use
  BuildAltArch="no"
  BuildCompFlags=""
  BuildFlags=""
  case $arch in
    i[3456]86 | athlon)
      BuildFlags="-march=$arch -mtune=generic"
      if [[ "`uname -m`" = "x86_64" ]]; then
        BuildAltArch="yes"
        BuildCompFlags="-m32"
      fi
      ;;
    x86_64)
      BuildFlags="-mtune=generic"
      ;;
    mips|mipsel)
      BuildFlags="-march=mips3"
      BuildCompFlags="-march=mips3"
      ;;
    mips32|mips32el)
      BuildFlags="-march=mips3 -mabi=n32"
      BuildCompFlags="-march=mips3 -mabi=n32"
      ;;
    mips64|mips64el)
      BuildFlags="-march=mips3 -mabi=64"
      BuildCompFlags="-march=mips3 -mabi=64"
      ;;
    armv4t*)
      BuildFlags="-march=armv4t"
      BuildCompFlags="-march=armv4t"
      ;;
    armv5t*)
      BuildFlags="-march=armv5t"
      BuildCompFlags="-march=armv5t"
      ;;
    # to check
    armv7*)
      BuildFlags="-march=armv7-a"
      BuildCompFlags="-march=armv7-a"
      ;;
  esac

  # Choose multiarch support
  MultiArchFlags=
  case $arch in
    i686 | x86_64)
      MultiArchFlags="--enable-multi-arch"
      ;;
  esac

  # Determine C & C++ compilers
  BuildCC="%{__cc} $BuildCompFlags"
  BuildCXX="%{__cxx} $BuildCompFlags"

  # Are we supposed to cross-compile?
  if [[ "%{target_cpu}" != "%{_target_cpu}" ]]; then
    # Can't use BuildCC anymore with previous changes.
    BuildCC="%{cross_program_prefix}gcc $BuildCompFlags"
    BuildCXX="%{cross_program_prefix}g++ $BuildCompFlags"
    BuildCross="--build=%{_target_platform}"
    export libc_cv_forced_unwind=yes libc_cv_c_cleanup=yes
  fi

  BuildFlags="$BuildFlags -DNDEBUG=1 -O2 -finline-functions -g"

  # Do not use direct references against %gs when accessing tls data
  # XXX make it the default in GCC? (for other non glibc specific usage)
  case $arch in
    i[3456]86 | x86_64)
      BuildFlags="$BuildFlags -mno-tls-direct-seg-refs"
      ;;
  esac

  # Arch specific compilation flags
  if [[ "$arch" = "ppc64" ]]; then
    BuildFlags="$BuildFlags -fno-inline-functions -mno-minimal-toc"
  fi

  # Extra configure flags
  ExtraFlags=
  if [[ "%{build_profile}" != "0" ]]; then
    ExtraFlags="$ExtraFlags --enable-profile"
  fi

  # NPTL+TLS are now the default
  # check for other arches
  %if %isarch %ports_arch
    Pthreads="ports nptl"
  %else
    Pthreads="nptl"
  %endif

  # Add-ons
  AddOns="libidn"
  if [[ "$cpu" != "$arch" ]]; then
    AddOns="$AddOns,powerpc-cpu"
    BuildFlags="$BuildFlags -mcpu=$cpu"
    ExtraFlags="$ExtraFlags --with-cpu=$cpu"
  fi

  # Build with selinux support?
%if %{build_selinux}
  SElinuxFlags="--with-selinux"
%else
  SElinuxFlags="--without-selinux"
%endif

  # Kernel headers directory
  KernelHeaders=%{_includedir}

  # Determine library name
  glibc_cv_cc_64bit_output=no
  if echo ".text" | $BuildCC -c -o test.o -xassembler -; then
    case `/usr/bin/file test.o` in
    *"ELF 64"*)
      glibc_cv_cc_64bit_output=yes
      ;;
    esac
  fi
  rm -f test.o

  # Force a separate and clean object dir
  rm -rf build-$cpu-linux
  mkdir  build-$cpu-linux
  pushd  build-$cpu-linux
  [[ "$BuildAltArch" = "yes" ]] && touch ".alt" || touch ".main"
  CC="$BuildCC" CXX="$BuildCXX" CFLAGS="$BuildFlags" ../configure \
    $arch-%{_real_vendor}-linux%{gnuext} $BuildCross \
    --prefix=%{_prefix} \
    --libexecdir=%{_prefix}/libexec \
    --infodir=%{_infodir} \
    --enable-add-ons="$AddOns" --without-cvs \
    $ExtraFlags $MultiArchFlags $SElinuxFlags \
    --enable-kernel=%{enablekernel} \
    --with-headers=$KernelHeaders ${1+"$@"} \
    --enable-obsolete-rpc
  %make -r -s
  popd

  # All tests are expected to pass on certain platforms, depending also
  # on the version of the kernel running
  case $arch in
  athlon | ia64 | ppc | ppc64)
    if [ "`CompareKver %{check_min_kver}`" -lt 0 ]; then
      check_flags=""
    else
      check_flags="-k"
    fi
    ;;
  *)
    check_flags="-k"
    ;;
  esac

  # Generate test matrix
  [[ -d "build-$arch-linux" ]] || {
    echo "ERROR: PrepareGlibcTest: build-$arch-linux does not exist!"
    return 1
  }
  local BuildJobs="-j`getconf _NPROCESSORS_ONLN`"
  echo "$BuildJobs -d build-$arch-linux $check_flags" >> $CheckList

  case $cpu in
  i686|athlon)	base_arch=i586;;
  power*)	base_arch=$arch;;
  *)		base_arch=none;;
  esac

  [[ -d "build-$base_arch-linux" ]] && {
    check_flags="$check_flags -l build-$base_arch-linux/elf/ld.so"
    echo "$BuildJobs -d build-$arch-linux $check_flags" >> $CheckList
  }
  return 0
}

# Build main glibc
BuildGlibc %{target_cpu}

%if %{build_biarch}
%if %isarch x86_64
BuildGlibc i686
%endif
%endif
%if %isarch mips
BuildGlibc mips64
BuildGlibc mips32
%endif
%if %isarch mipsel
BuildGlibc mips64el
BuildGlibc mips32el
%endif
%if %isarch mips64
BuildGlibc mips
BuildGlibc mips32
%endif
%if %isarch mips64el
BuildGlibc mipsel
BuildGlibc mips32el
%endif

# Build i686 libraries if not already building for i686/athlon
case %{target_cpu} in
  i686 | athlon)
    ;;
  i[3-6]86)
    BuildGlibc i686 --disable-profile
    ;;
esac

make -C crypt_blowfish-%{crypt_bf_ver} man

%if %{build_check}
export TMPDIR=/tmp
export TIMEOUTFACTOR=16
Check="$PWD/glibc-check.sh"
cat %{SOURCE5} > $Check
chmod +x $Check
while read arglist; do
  $Check $arglist || exit 1
done < $CheckList
%endif

%install
# force use of _NPROCESSORS_ONLN jobs since RPM_BUILD_NCPUS could be
# greater for icecream
BuildJobs="-j`getconf _NPROCESSORS_ONLN`"

make install_root=$RPM_BUILD_ROOT install -C build-%{target_cpu}-linux
%if %{build_i18ndata}
(cd build-%{target_cpu}-linux;
  make $BuildJobs -C ../localedata objdir=`pwd` \
	install_root=$RPM_BUILD_ROOT \
	install-locales
)
install -m 0644 localedata/SUPPORTED $RPM_BUILD_ROOT/%{_datadir}/i18n/
%endif

# Empty filelist for non i686/athlon targets
> extralibs.filelist

# Install biarch libraries
%if %{build_biarch} || %isarch mips mipsel
%if %isarch x86_64
ALT_ARCHES=i686-linux
%endif
%if %isarch mips
ALT_ARCHES="mips64-linux mips32-linux"
%endif
%if %isarch mipsel
ALT_ARCHES="mips64el-linux mips32el-linux"
%endif
%if %isarch mips64
ALT_ARCHES="mips-linux mips32-linux"
%endif
%if %isarch mips64el
ALT_ARCHES="mipsel-linux mips32el-linux"
%endif

for ALT_ARCH in $ALT_ARCHES; do
mkdir -p $RPM_BUILD_ROOT/$ALT_ARCH
make install_root=$RPM_BUILD_ROOT/$ALT_ARCH install -C build-$ALT_ARCH

# Dispatch */lib only
case "$ALT_ARCH" in
	mips32*)
		LIB="%{_slibdir}32"
		;;
	mips64*)
		LIB="%{_slibdir}64"
		;;
	*)
		LIB=/lib
		;;
esac
%if !%{build_cross}
mv     $RPM_BUILD_ROOT/$ALT_ARCH/$LIB $RPM_BUILD_ROOT/$LIB
mv     $RPM_BUILD_ROOT/$ALT_ARCH%{_prefix}/libexec/getconf/* \
       $RPM_BUILD_ROOT%{_prefix}/libexec/getconf/
[ ! -d $RPM_BUILD_ROOT/%{_prefix}/$LIB/ ] && mkdir -p $RPM_BUILD_ROOT/%{_prefix}/$LIB/
mv     $RPM_BUILD_ROOT/$ALT_ARCH/%{_prefix}/$LIB/* $RPM_BUILD_ROOT/%{_prefix}/$LIB/
%else
mv     $RPM_BUILD_ROOT/$ALT_ARCH/%{_prefix}/lib $RPM_BUILD_ROOT/$LIB
sed -i $RPM_BUILD_ROOT/$LIB/libc.so -e "s!%{_slibdir}!$LIB!g"
%endif

rm -rf $RPM_BUILD_ROOT/$ALT_ARCH
# XXX Dispatch 32-bit stubs
(sed '/^@/d' include/stubs-prologue.h; LC_ALL=C sort $(find build-$ALT_ARCH -name stubs)) \
> $RPM_BUILD_ROOT%{_includedir}/gnu/stubs-32.h
done
%endif

# Install extra glibc libraries
function InstallGlibc() {
  local BuildDir="$1"
  local SubDir="$2"
  local LibDir="$3"

  case $BuildDir in
  *)      Pthreads=nptl         ;;
  esac

  [[ -z "$LibDir" ]] && LibDir="%{_slibdir}"

  pushd $BuildDir
  mkdir -p $RPM_BUILD_ROOT$LibDir/$SubDir/
  install -m755 libc.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libc-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libc-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libc.so.*`
  install -m755 math/libm.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libm-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libm-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libm.so.*`
  install -m755 $Pthreads/libpthread.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libpthread-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libpthread-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libpthread.so.*`
  install -m755 ${Pthreads}_db/libthread_db.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libthread_db-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/libthread_db-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/libthread_db.so.*`
  install -m755 rt/librt.so $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/librt-*.so`
  ln -sf `basename $RPM_BUILD_ROOT$LibDir/librt-*.so` $RPM_BUILD_ROOT$LibDir/$SubDir/`basename $RPM_BUILD_ROOT$LibDir/librt.so.*`
  echo "%dir $LibDir/$SubDir" >> ../extralibs.filelist
  find $RPM_BUILD_ROOT$LibDir/$SubDir -maxdepth 1  -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||" >> ../extralibs.filelist
  popd
}

# Install arch-specific optimized libraries
%if %isarch %{ix86}
case %{target_cpu} in
i[3-5]86)
  InstallGlibc build-i686-linux i686
  ;;
esac
%endif

# NPTL <bits/stdio-lock.h> is not usable outside of glibc, so include
# the generic one (RH#162634)
install -m644 bits/stdio-lock.h $RPM_BUILD_ROOT%{_includedir}/bits/stdio-lock.h
# And <bits/libc-lock.h> needs sanitizing as well.
install -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_includedir}/bits/libc-lock.h

# Compatibility hack: this locale has vanished from glibc, but some other
# programs are still using it. Normally we would handle it in the %pre
# section but with glibc that is simply not an option
mkdir -p $RPM_BUILD_ROOT%{_datadir}/locale/ru_RU/LC_MESSAGES

# Remove the files we don't want to distribute
rm -f $RPM_BUILD_ROOT%{_libdir}/libNoVersion*
rm -f $RPM_BUILD_ROOT%{_slibdir}/libNoVersion*

%if "%{name}" == "glibc"
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_sysconfdir}/nsswitch.conf
%endif

# This is for ncsd - in glibc 2.2
%if %{build_nscd}
install -m 644 nscd/nscd.conf $RPM_BUILD_ROOT%{_sysconfdir}
install -d -m 755 %{buildroot}%{_unitdir}
install -m 644 %{SOURCE6} %{buildroot}%{_unitdir}/nscd.service
install -m 644 %{SOURCE7} %{buildroot}%{_unitdir}/nscd.socket
install -D -m 644 %{SOURCE9} %{buildroot}%{_tmpfilesdir}/nscd.conf
install -d -m 755 %{buildroot}%{_var}/db/nscd
%endif

# These man pages require special attention
mkdir -p %{buildroot}%{_mandir}/man3
install -p -m 0644 crypt_blowfish-%{crypt_bf_ver}/*.3 %{buildroot}%{_mandir}/man3/

# Useless and takes place
rm -rf %buildroot/%{_datadir}/zoneinfo/{posix,right}

# Include ld.so.conf
%if "%{name}" == "glibc"
%if %isarch mips mipsel
# needed to get a ldd which understands o32, n32, 64
install -m 755 $RPM_BUILD_DIR/%{source_dir}/build-mips64el-linux/elf/ldd $RPM_BUILD_ROOT/%{_bindir}/ldd
%endif
echo "include /etc/ld.so.conf.d/*.conf" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf
mkdir -p  $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d

# ldconfig cache
mkdir -p $RPM_BUILD_ROOT%{_var}/cache/ldconfig
touch $RPM_BUILD_ROOT%{_var}/cache/ldconfig/aux-cache

# automatic ldconfig cache update on rpm installs/removals
# (see http://wiki.mandriva.com/en/Rpm_filetriggers)
install -d %buildroot%{_var}/lib/rpm/filetriggers
cat > %buildroot%{_var}/lib/rpm/filetriggers/00-ldconfig.filter << EOF
^.((/lib|/usr/lib)(32|64)?/[^/]*\.so\.|/etc/ld.so.conf.d/[^/]*\.conf)
EOF
cat > %buildroot%{_var}/lib/rpm/filetriggers/00-ldconfig.script << EOF
#!/bin/sh
ldconfig -X
EOF
chmod 0755 %buildroot%{_var}/lib/rpm/filetriggers/00-ldconfig.script
%endif

# Include %{_libdir}/gconv/gconv-modules.cache
> $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules.cache
chmod 644 $RPM_BUILD_ROOT%{_libdir}/gconv/gconv-modules.cache

%if "%{name}" == "glibc"
touch $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.cache
%endif

# Add libraries to debug sub-package
%if %{build_debug}
mkdir $RPM_BUILD_ROOT%{_libdir}/debug
#cp -a $RPM_BUILD_ROOT%{_libdir}/*.a $RPM_BUILD_ROOT%{_libdir}/debug/
#rm -f $RPM_BUILD_ROOT%{_libdir}/debug/*_p.a
cp -a $RPM_BUILD_ROOT%{_slibdir}/lib*.so* $RPM_BUILD_ROOT%{_libdir}/debug/

pushd $RPM_BUILD_ROOT%{_libdir}/debug
for lib in *.so*; do
  [[ -f "$lib" ]] && DEBUG_LIBS="$DEBUG_LIBS %{_libdir}/debug/$lib"
done
popd
%endif

# Are we cross-compiling?
Strip="strip"
if [[ "%{_target_cpu}" != "%{target_cpu}" ]]; then
  Strip="%{cross_program_prefix}$Strip"
fi

# Strip debugging info from all static libraries
pushd $RPM_BUILD_ROOT%{_slibdir}
for i in *.a; do
  if [ -f "$i" ]; then
    case "$i" in
    *_p.a) ;;
    *) $Strip -g -R .comment $i ;;
    esac
  fi
done
popd

# post install wrapper
%__cc -Os -DSLIBDIR="\"%{_slibdir}\"" -DASH_BIN="\"%{ash_bin}\"" %{SOURCE14} -static \
	-L $RPM_BUILD_ROOT%{_libdir}/ \
	-o $RPM_BUILD_ROOT%{_sbindir}/glibc-post-wrapper
chmod 700 $RPM_BUILD_ROOT%{_sbindir}/glibc-post-wrapper

# rquota.x and rquota.h are now provided by quota
rm -f $RPM_BUILD_ROOT%{_includedir}/rpcsvc/rquota.[hx]

# Hardlink identical locale files together
%if %{build_i18ndata}
%{_sbindir}/hardlink -vc $RPM_BUILD_ROOT%{_datadir}/locale
%endif

rm -rf $RPM_BUILD_ROOT%{_includedir}/netatalk/

# Build file list for devel package
find $RPM_BUILD_ROOT%{_includedir} -type f -or -type l > devel.filelist
find $RPM_BUILD_ROOT%{_includedir} -type d  | sed "s/^/%dir /" | \
  grep -v "%{_libdir}/libnss1.*.so$" | \
  grep -v "%{_includedir}$" | >> devel.filelist
find $RPM_BUILD_ROOT%{_libdir} -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
# biarch libs
%if %{build_biarch}
find $RPM_BUILD_ROOT%{_prefix}/lib -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
%endif
%if %isarch mips mipsel
find $RPM_BUILD_ROOT%{_libdir}32 -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
find $RPM_BUILD_ROOT%{_libdir}64 -maxdepth 1 -name "*.so" -o -name "*.o" | egrep -v "(libmemusage.so|libpcprofile.so)" >> devel.filelist
%endif
perl -pi -e "s|$RPM_BUILD_ROOT||" devel.filelist

# /etc/localtime - we're proud of our timezone #Well we may put Paris
%if %{build_timezone}
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/localtime
cp -f $RPM_BUILD_ROOT%{_datadir}/zoneinfo/US/Eastern $RPM_BUILD_ROOT%{_sysconfdir}/localtime
#ln -sf ..%{_datadir}/zoneinfo/US/Eastern $RPM_BUILD_ROOT%{_sysconfdir}/localtime
%endif

# [gg] build PDF documentation
%if %{build_pdf_doc}
(cd manual; texi2dvi -p -t @afourpaper -t @finalout libc.texinfo)
%endif

# the last bit: more documentation
rm -rf documentation
mkdir documentation
cp timezone/README documentation/README.timezone
cp ChangeLog* documentation
gzip -9 documentation/ChangeLog*
mkdir documentation/crypt_blowfish-%{crypt_bf_ver}
install -m 644 crypt_blowfish-%{crypt_bf_ver}/{README,LINKS,PERFORMANCE} \
	documentation/crypt_blowfish-%{crypt_bf_ver}

# Generate final rpm filelist, with localized libc.mo files
rm -f rpm.filelist
%if "%{name}" == "glibc"
%find_lang libc
perl -ne '/^\s*$/ or print' libc.lang > rpm.filelist
%endif
cat extralibs.filelist >> rpm.filelist

# Remove unpackaged files
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir.old*
rm -rf $RPM_BUILD_ROOT%{_includedir}/asm-*/mach-*/
rm -f  $RPM_BUILD_ROOT%{_datadir}/locale/locale-archive*
rm -f  $RPM_BUILD_ROOT%{_var}/db/Makefile

%if !%{build_utils}
%if %{build_biarch}
rm -f  $RPM_BUILD_ROOT%{_slibdir32}/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir32}/libpcprofile.so
%endif
%if %isarch mips mipsel
rm -f  $RPM_BUILD_ROOT%{_slibdir}32/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}32/libpcprofile.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}64/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}64/libpcprofile.so
%endif
rm -f  $RPM_BUILD_ROOT%{_slibdir}/libmemusage.so
rm -f  $RPM_BUILD_ROOT%{_slibdir}/libpcprofile.so
rm -f  $RPM_BUILD_ROOT%{_bindir}/memusage
rm -f  $RPM_BUILD_ROOT%{_bindir}/memusagestat
rm -f  $RPM_BUILD_ROOT%{_bindir}/mtrace
rm -f  $RPM_BUILD_ROOT%{_bindir}/pcprofiledump
rm -f  $RPM_BUILD_ROOT%{_bindir}/xtrace
%endif

%if !%{build_timezone}
rm -f  $RPM_BUILD_ROOT%{_sysconfdir}/localtime
rm -f  $RPM_BUILD_ROOT%{_sbindir}/zdump
rm -f  $RPM_BUILD_ROOT%{_sbindir}/zic
rm -rf $RPM_BUILD_ROOT%{_datadir}/zoneinfo
%endif

%if !%{build_i18ndata}
rm -rf $RPM_BUILD_ROOT%{_datadir}/i18n
%endif

%if "%{name}" != "glibc"
rm -rf $RPM_BUILD_ROOT/boot
rm -rf $RPM_BUILD_ROOT/sbin
rm -rf $RPM_BUILD_ROOT/usr/share
rm -rf $RPM_BUILD_ROOT%{_bindir}
rm -rf $RPM_BUILD_ROOT%{_sbindir}
rm -rf $RPM_BUILD_ROOT%{_datadir}
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -rf $RPM_BUILD_ROOT%{_prefix}/etc
rm -rf $RPM_BUILD_ROOT%{_libdir}/gconv
%endif

# In case we are cross-compiling, don't bother to remake symlinks and
# fool spec-helper when stripping files
%if "%{name}" != "glibc"
export DONT_SYMLINK_LIBS=1
export PATH=%{_bindir}:$PATH
%endif

%if %build_debug
export EXCLUDE_FROM_STRIP="$DEBUG_LIBS"
%endif

# This will make the '-g' argument to be passed to eu-strip for these
# libraries, so that only debug symbols are stripped and gdb/valgrind continue
# to work without needing glibc-debug package to be installed.
export EXCLUDE_FROM_FULL_STRIP="ld-%{glibcversion}.so libpthread libc-%{glibcversion}.so"

%if "%{name}" == "glibc"
%define upgradestamp %{_slibdir}/glibc.upgraded
%define broken_link %{_slibdir}/libnss_nis.so.1 %{_slibdir}/libnss_files.so.1 %{_slibdir}/libnss_dns.so.1 %{_slibdir}/libnss_compat.so.1


%pre -p <lua>
if posix.stat("/usr%{_slibdir}", "type") == 'directory' then
  if not posix.stat("/usr%{_slibdir}/libnss_files-%{glibcversion}.so") then
     io.open("%{upgradestamp}", "w"):close()
  end
end

%post -p %{_sbindir}/glibc-post-wrapper
export LC_ALL=C

if [ "$1" -gt 1 ]; then
  # migrate /etc/ld.so.conf to include the new /etc/ld.so.conf.d/
  # without external commands but for removing the temporary file
  ldso_conf=/etc/ld.so.conf
  while read i; do
    [ "$i" = "include /etc/ld.so.conf.d/*.conf" ] && keep=1
    # Remove previously used include line without absolute path
    [ "$i" = "include ld.so.conf.d/*.conf" ] || echo $i
  done < $ldso_conf > $ldso_conf-
  if [ -z "$keep" ]; then
    echo "include /etc/ld.so.conf.d/*.conf" > $ldso_conf
    while read i; do
      echo $i
    done < $ldso_conf- >> $ldso_conf
  fi
  [ -x /bin/rm ] && /bin/rm -f $ldso_conf-
fi
/sbin/ldconfig

if [ "$1" -gt 1 ]; then
  # On upgrade the services doesn't work because libnss couldn't be
  # loaded anymore.
  if [ -f %{upgradestamp} ]; then
    if /usr/bin/readlink /proc/1/exe >/dev/null && \
       /usr/bin/readlink /proc/1/root >/dev/null; then
       if [ -x /sbin/telinit -a -p /dev/initctl ]; then
         /sbin/telinit u
       fi
       if [ -x /etc/init.d/sshd -a \
            -x /usr/sbin/sshd -a \
            -x /bin/bash ]; then
         /etc/init.d/sshd condrestart
       fi
    fi
  fi
  if [ -f /bin/rm ]; then
    for i in %broken_link; do
      if [ -e $i ] && [ ! -L $i ]; then
        /bin/rm -f $i
      fi
    done
  fi
fi
[ -x /bin/rm ] && /bin/rm -f %{upgradestamp}

# always generate the gconv-modules.cache
%{_sbindir}/iconvconfig -o %{_libdir}/gconv/gconv-modules.cache --nostdlib %{_libdir}/gconv

%endif

%pre devel
if [ -L %{_includedir}/scsi ]; then
  rm -f %{_includedir}/scsi
fi
if [ -L %{_includedir}/sound ]; then
  rm -f %{_includedir}/sound
fi
if [ -L %{_includedir}/linux ]; then
  rm -f %{_includedir}/linux
fi
if [ -L %{_includedir}/asm ]; then
  rm -f %{_includedir}/asm
fi
if [ -L %{_includedir}/asm-generic ]; then
  rm -f %{_includedir}/asm-generic
fi
%if %isarch x86_64
if [ -L %{_includedir}/asm-x86_64 ]; then
  rm -f %{_includedir}/asm-x86_64
fi
if [ -L %{_includedir}/asm-i386 ]; then
  rm -f %{_includedir}/asm-i386
fi
%endif
%if %isarch %mips
if [ -L %{_includedir}/asm-mips ]; then
  rm -f %{_includedir}/asm-mips
fi
%endif
%if %isarch %arm
if [ -L %{_includedir}/asm-arm ]; then
  rm -f %{_includedir}/asm-arm
fi
%endif
exit 0

%if %{build_doc}
%post doc
%_install_info libc.info

%preun doc
%_remove_install_info libc.info
%endif

%if %{build_nscd}
%pre -n nscd
%_pre_useradd nscd / /bin/false

%post -n nscd
%_tmpfilescreate nscd
%_post_service nscd

%preun -n nscd
%_preun_service nscd

%postun -n nscd
%_postun_userdel nscd

if [ "$1" -ge "1" ]; then
  /sbin/service nscd condrestart > /dev/null 2>&1 || :
fi
%endif

%clean
#rm -rf "$RPM_BUILD_ROOT"
#rm -f *.filelist*

#
# glibc
#
%files -f rpm.filelist
%if "%{name}" == "glibc"
%if %{build_timezone}
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/localtime
%endif
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/nsswitch.conf
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/ld.so.conf
%dir %{_sysconfdir}/ld.so.conf.d
%config(noreplace) %{_sysconfdir}/rpc
%doc nis/nss
%doc posix/gai.conf
%{_datadir}/locale/locale.alias
/sbin/sln
%dir %{_prefix}/libexec/getconf
%{_prefix}/libexec/getconf/*
%endif
%{_slibdir}/ld-%{glibcversion}.so
%if %isarch i386
%{_slibdir}/ld-linux.so.2
%endif
%if %isarch %arm
%{_slibdir}/ld-linux.so.3
%endif
%if %isarch x86_64
%{_slibdir}/ld-linux-x86-64.so.2
%endif
%if %isarch %mips
%{_slibdir}/ld.so.1
%endif
%{_slibdir}/lib*-[.0-9]*.so
%{_slibdir}/lib*.so.[0-9]*
%{_slibdir}/libSegFault.so
%if "%{name}" == "glibc"
%dir %{_libdir}/audit
%{_libdir}/audit/sotruss-lib.so
%dir %{_libdir}/gconv
%{_libdir}/gconv/*.so
%{_libdir}/gconv/gconv-modules
%ghost %{_libdir}/gconv/gconv-modules.cache
%{_bindir}/catchsegv
%{_bindir}/gencat
%{_bindir}/getconf
%{_bindir}/getent
%{_bindir}/iconv
%{_bindir}/ldd
%if %isarch i386
%{_bindir}/lddlibc4
%endif
%{_bindir}/locale
%{_bindir}/localedef
%{_bindir}/makedb
%{_bindir}/pldd
%{_bindir}/rpcgen
%{_bindir}/sotruss
%{_bindir}/sprof
%{_bindir}/tzselect
%{_sbindir}/iconvconfig
%{_sbindir}/glibc-post-wrapper
%endif

%if %{build_biarch}
%{_slibdir32}/ld-%{glibcversion}.so
%{_slibdir32}/ld-linux*.so.2
%{_slibdir32}/lib*-[.0-9]*.so
%{_slibdir32}/lib*.so.[0-9]*
%{_slibdir32}/libSegFault.so
%dir %{_prefix}/lib/audit
%{_prefix}/lib/audit/sotruss-lib.so
%dir %{_prefix}/lib/gconv
%{_prefix}/lib/gconv/*
%endif
%if %isarch mips mipsel
%{_slibdir}32/ld-%{glibcversion}.so
%{_slibdir}32/ld.so.1
%{_slibdir}32/lib*-[.0-9]*.so
%{_slibdir}32/lib*.so.[0-9]*
%{_slibdir}32/libSegFault.so
%dir %{_libdir}32/gconv
%{_libdir}32/gconv/*
%{_slibdir}64/ld-%{glibcversion}.so
%{_slibdir}64/ld.so.1
%{_slibdir}64/lib*-[.0-9]*.so
%{_slibdir}64/lib*.so.[0-9]*
%{_slibdir}64/libSegFault.so
%dir %{_libdir}64/gconv
%{_libdir}64/gconv/*
%endif

#
# ldconfig
#
%if "%{name}" == "glibc"
/sbin/ldconfig
%ghost %{_sysconfdir}/ld.so.cache
%dir %{_var}/cache/ldconfig
%ghost %{_var}/cache/ldconfig/aux-cache
%{_var}/lib/rpm/filetriggers/00-ldconfig.*
%endif

#
# glibc-devel
#
%files devel -f devel.filelist
%doc README NEWS INSTALL BUGS PROJECTS CONFORMANCE
%doc COPYING COPYING.LIB
%doc documentation/*
%doc hesiod/README.hesiod
%doc crypt/README.ufc-crypt
%if "%{name}" == "glibc"
%{_mandir}/man3/*
%endif
%{_libdir}/libc_nonshared.a
%{_libdir}/libg.a
%{_libdir}/libieee.a
%{_libdir}/libmcheck.a
%{_libdir}/libpthread_nonshared.a
%if "%{name}" == "glibc"
%{_libdir}/librpcsvc.a
%endif

%if %{build_biarch}
%{_prefix}/lib/libc_nonshared.a
%{_prefix}/lib/libg.a
%{_prefix}/lib/libieee.a
%{_prefix}/lib/libmcheck.a
%{_prefix}/lib/libpthread_nonshared.a
%{_prefix}/lib/librpcsvc.a
%endif

%if %isarch mips mipsel
%{_libdir}32/libc_nonshared.a
%{_libdir}32/libg.a
%{_libdir}32/libieee.a
%{_libdir}32/libmcheck.a
%{_libdir}32/libpthread_nonshared.a
%if "%{name}" == "glibc"
%{_libdir}32/librpcsvc.a
%endif
%{_libdir}64/libc_nonshared.a
%{_libdir}64/libg.a
%{_libdir}64/libieee.a
%{_libdir}64/libmcheck.a
%{_libdir}64/libpthread_nonshared.a
%if "%{name}" == "glibc"
%{_libdir}64/librpcsvc.a
%endif
%endif

#
# glibc-static-devel
#
%files static-devel
%doc COPYING COPYING.LIB
%{_libdir}/libBrokenLocale.a
%{_libdir}/libanl.a
%{_libdir}/libc.a
%{_libdir}/libcrypt.a
%{_libdir}/libdl.a
%{_libdir}/libm.a
%{_libdir}/libnsl.a
%{_libdir}/libpthread.a
%{_libdir}/libresolv.a
%{_libdir}/librt.a
%{_libdir}/libutil.a

%if %{build_biarch}
%{_prefix}/lib/libBrokenLocale.a
%{_prefix}/lib/libanl.a
%{_prefix}/lib/libc.a
%{_prefix}/lib/libcrypt.a
%{_prefix}/lib/libdl.a
%{_prefix}/lib/libm.a
%{_prefix}/lib/libnsl.a
%{_prefix}/lib/libpthread.a
%{_prefix}/lib/libresolv.a
%{_prefix}/lib/librt.a
%{_prefix}/lib/libutil.a
%endif

%if %isarch mips mipsel
%{_libdir}32/libBrokenLocale.a
%{_libdir}32/libanl.a
%{_libdir}32/libc.a
%{_libdir}32/libcrypt.a
%{_libdir}32/libdl.a
%{_libdir}32/libm.a
%{_libdir}32/libnsl.a
%{_libdir}32/libpthread.a
%{_libdir}32/libresolv.a
%{_libdir}32/librt.a
%{_libdir}32/libutil.a

%{_libdir}64/libBrokenLocale.a
%{_libdir}64/libanl.a
%{_libdir}64/libc.a
%{_libdir}64/libcrypt.a
%{_libdir}64/libdl.a
%{_libdir}64/libm.a
%{_libdir}64/libnsl.a
%{_libdir}64/libpthread.a
%{_libdir}64/libresolv.a
%{_libdir}64/librt.a
%{_libdir}64/libutil.a
%endif

#
# glibc-doc
#
%if %{build_doc}
%files doc
%{_infodir}/libc.info*
%endif

#
# glibc-doc-pdf
#
%if %{build_pdf_doc}
%files doc-pdf
%doc manual/libc.pdf
%endif

#
# glibc-debug
#
%if %{build_debug}
%files debug
%dir %{_libdir}/debug
%{_libdir}/debug/*.so
%{_libdir}/debug/*.so.*
%if %isarch mips mipsel
%dir %{_libdir}/debug/lib32
%{_libdir}/debug/lib32/*.so
%{_libdir}/debug/lib32/*.so.*
%dir %{_libdir}/debug/lib64
%{_libdir}/debug/lib64/*.so
%{_libdir}/debug/lib64/*.so.*
%endif
%endif

#
# glibc-profile
#
%if %{build_profile}
%files profile
%{_libdir}/lib*_p.a
%if %{build_biarch}
%{_prefix}/lib/lib*_p.a
%endif
%if %isarch mips mipsel
%{_libdir}32/lib*_p.a
%{_libdir}64/lib*_p.a
%endif
%endif

#
# glibc-utils
#
%if %{build_utils}
%files utils
%if %{build_biarch}
%{_slibdir32}/libmemusage.so
%{_slibdir32}/libpcprofile.so
%endif
%{_slibdir}/libmemusage.so
%{_slibdir}/libpcprofile.so
%{_bindir}/memusage
%{_bindir}/memusagestat
%{_bindir}/mtrace
%{_bindir}/pcprofiledump
%{_bindir}/xtrace
%if %isarch mips mipsel
%{_slibdir}32/libmemusage.so
%{_slibdir}32/libpcprofile.so
%{_slibdir}64/libmemusage.so
%{_slibdir}64/libpcprofile.so
%endif
%endif

#
# nscd
#
%if %{build_nscd}
%files -n nscd
%config(noreplace) %{_sysconfdir}/nscd.conf
%{_sbindir}/nscd
%{_unitdir}/nscd.service
%{_unitdir}/nscd.socket
%{_tmpfilesdir}/nscd.conf
%dir %{_var}/db/nscd
%endif

#
# timezone
#
%if %{build_timezone}
%files -n timezone
%{_sbindir}/zdump
%{_sbindir}/zic
%dir %{_datadir}/zoneinfo
%{_datadir}/zoneinfo/*
%endif

#
# glibc-i18ndata
#
%if %{build_i18ndata}
%files i18ndata
%dir %{_datadir}/i18n
%dir %{_datadir}/i18n/charmaps
%{_datadir}/i18n/charmaps/*
%dir %{_datadir}/i18n/locales
%{_datadir}/i18n/locales/*
%{_datadir}/i18n/SUPPORTED
%endif


%changelog
* Sun May 22 2016 tmb <tmb> 6:2.20-22.mga5
+ Revision: 1017669
- glob: Simplify the interface for the GLOB_ALTDIRFUNC callback gl_readdir
- CVE-2016-1234: glob: Do not copy d_name field of struct dirent [BZ #19779]
- CVE-2016-3075: Stack overflow in _nss_dns_getnetbyname_r [BZ #19879]
- CVE-2016-3706: getaddrinfo: stack overflow in hostent conversion [BZ #20010]
- getaddrinfo() stack-based buffer overflow [BZ 18665] (CVE-2015-7547)
- nan function unbounded stack allocation [BZ 16961, 16962] (CVE-2014-9761)
- catopen() Multiple unbounded stack allocations [BZ 17905] (CVE-2015-8779)
- hcreate, hcreate_r should fail with ENOMEM if element count is too large [BZ 18240] (CVE-2015-8778)
- out of range data to strftime() causes a segfault [BZ 18985] (CVE-2015-8776)
- Always enable pointer guard [BZ #18928] (CVE-2015-8777)

* Sat May 02 2015 tmb <tmb> 6:2.20-20.mga5
+ Revision: 821015
- Do not close NSS files database during iteration [BZ #18007] (CVE-2014-8121)

* Fri May 01 2015 tmb <tmb> 6:2.20-19.mga5
+ Revision: 821001
- resolv/nss_dns/dns-host.c buffer overflow (CVE-2015-1781) [BZ#18287]

* Sun Apr 19 2015 tmb <tmb> 6:2.20-18.mga5
+ Revision: 820468
- nscd needs /var/db/nscd (mga#15545)

* Sat Apr 18 2015 tmb <tmb> 6:2.20-17.mga5
+ Revision: 820464
- Fix _IO_wstr_overflow integer overflow (PR/BZ #17269)
- Fix read past end of pattern in fnmatch (PR/BZ #18032)

* Sat Feb 21 2015 tmb <tmb> 6:2.20-16.mga5
+ Revision: 816252
- sync with upstream glibc-2.20 maintenance branch:
  * Update Russian translation
  * Revert to defining __extern_inline only for gcc-4.3+ (BZ #17266)
  * Update French translation
  * BZ#17460: Fix buffer overrun in nscd --help
  * MIPS: Avoid a dangling `vfork@GLIBC_2.0' reference
  * AArch64: End frame record chain correctly
  * Make __extern_always_inline usable on clang++ again
  * Move findidx nested functions to top-level
  * Fix memory handling in strxfrm_l [BZ #16009] (CVE pending)
  * Use AVX unaligned memcpy only if AVX2 is available

* Sun Feb 08 2015 tmb <tmb> 6:2.20-15.mga5
+ Revision: 814068
- wscanf allocates too little memory (CVE-2015-1472, CVE-2015-1473)

* Sun Dec 21 2014 tmb <tmb> 6:2.20-14.mga5
+ Revision: 804687
- Fix stack overflow in vfprintf [BZ #16617] (CVE-2012-3406)
- Avoid infinite loop in nss_dns getnetbyname [BZ #17630] (CVE-2014-9402)

* Sat Nov 22 2014 tmb <tmb> 6:2.20-12.mga5
+ Revision: 798301
- posix wordexp fails to honour WRDE_NOCMD (CVE-2014-7817)

* Wed Oct 15 2014 tmb <tmb> 6:2.20-11.mga5
+ Revision: 751288
- elf/dl-load.c (open_path): Avoid writing to 'env_path_list'
  when none of the search directories exist. (BZ #15378)
- Fix infinite loop in check_pf (BZ #12926)
- disable lock elision again

* Fri Oct 10 2014 tmb <tmb> 6:2.20-10.mga5
+ Revision: 737970
- re-enable lock elision for now as disabling it triggesrs SIGILL traps

* Fri Oct 10 2014 tmb <tmb> 6:2.20-9.mga5
+ Revision: 737928
- add missing checks on ELIDE_UNLOCK for disabled lock elision (mga#14172)

* Fri Oct 10 2014 tmb <tmb> 6:2.20-8.mga5
+ Revision: 737868
- ensure adaptive elision in rwlocks is disabled (mga#14172)

* Thu Oct 09 2014 tv <tv> 6:2.20-7.mga5
+ Revision: 737764
- convert %%pretrans from dash to lua (one less Requires(pre), one less dep loop)
  (note that previous scriptlet was broken since UsrMove)

* Sun Sep 28 2014 tmb <tmb> 6:2.20-6.mga5
+ Revision: 731421
- disable lock-elision as glibc breaks on intel microcode update

* Thu Sep 25 2014 tmb <tmb> 6:2.20-5.mga5
+ Revision: 724574
- Fix memory leak in libio/wfileops.c do_ftell_wide [BZ #17370]
- Fix memory leak in error path of do_ftell_wide [BZ #17370]

  + tv <tv>
    - autoconvert to new prov/req excludes

* Sat Sep 13 2014 tmb <tmb> 6:2.20-4.mga5
+ Revision: 674978
- fix segfault in getifaddrs_internal [BZ#17371]
- malloc: additional unlink hardening for non-small bins [BZ#17344]
- Add new Linux 3.16 constants to netinet/udp.h

* Tue Sep 09 2014 tmb <tmb> 6:2.20-3.mga5
+ Revision: 674336
- submit to release

* Mon Sep 08 2014 tmb <tmb> 6:2.20-2.mga5
+ Revision: 673679
- hp-timing.c is dropped upstream
- rebase some patches so they apply
- dont use conditional patching for mips build
- drop old powerpc fix
- nptl is not an addon anymore, adjust build accordingly
- drop merged patches
- update to 2.20

* Thu Sep 04 2014 tmb <tmb> 6:2.19-12.mga5
+ Revision: 672173
- fix crashes on invalid input in IBM gconv modules [BZ #17325] (CVE-2014-6040)

* Thu Aug 28 2014 tmb <tmb> 6:2.19-11.mga5
+ Revision: 669052
- _gconv_translit_find: Disable function [BZ #17187]
  (CVE-2014-5119) (mga#13995)

* Sun Jul 27 2014 tmb <tmb> 6:2.19-10.mga5
+ Revision: 657579
- rebuild with fixed gcc

* Wed Jul 23 2014 tmb <tmb> 6:2.19-9.mga5
+ Revision: 656122
- setlocale: Use the heap for the copy of the locale argument
- _nl_find_locale: Improve handling of crafted locale names
  (BZ#17137, CVE-2014-0475)

* Wed Jul 23 2014 colin <colin> 6:2.19-8.mga5
+ Revision: 655883
- Rename ldconfig filetrigger to make sure it's run first

* Sun Jun 29 2014 tmb <tmb> 6:2.19-7.mga5
+ Revision: 640940
-  posix_spawn_file_actions_addopen needs to copy the path argument
   (BZ 17048, CVE-2014-4043)

* Tue May 13 2014 tmb <tmb> 6:2.19-6.mga5
+ Revision: 622540
- rebuild with gcc 4.9

* Wed May 07 2014 tmb <tmb> 6:2.19-3.mga5
+ Revision: 620910
- misc/sys/xattr.h: guard against linux uapi header inclusion

* Sat Mar 01 2014 tmb <tmb> 6:2.19-2.mga5
+ Revision: 598263
- Fix sign of input to bsloww1 (glibc #16623)
- Update x86_64 libm-test-ulps on AMD family 21h model 1 (glibc #16545)

* Mon Feb 17 2014 tmb <tmb> 6:2.19-1.mga5
+ Revision: 593923
- submit to /release

* Sat Feb 08 2014 tmb <tmb> 6:2.19-0.1.mga5
+ Revision: 585854
- drop P12, ancient  ppc fix
- dummy libbsd now removed upstream
- rediff P06, P11, P44
- drop merged patches
- update to 2.19

* Wed Feb 05 2014 tmb <tmb> 6:2.18-10.mga5
+ Revision: 582832
- x86: Disable x87 inline functions for SSE2 math

* Sun Jan 05 2014 tmb <tmb> 6:2.18-9.mga4
+ Revision: 564795
- malloc: Fix race in free() of fastbin chunk (Glibc BZ #15073)

* Wed Dec 04 2013 tmb <tmb> 6:2.18-8.mga4
+ Revision: 555189
- Print the reason why preloading failed in do_preload()
- Fix PI mutex check in pthread_cond_broadcast and pthread_cond_signal

* Fri Oct 25 2013 tmb <tmb> 6:2.18-7.mga4
+ Revision: 546939
- Fix stack overflow due to large AF_INET6 requests (CVE-2013-4458)

* Wed Oct 16 2013 tmb <tmb> 6:2.18-6.mga4
+ Revision: 501486
- rebuild with new gcc & binutils
- Fix handling LC_CTYPE nonascii-case fallback in i686 SSE4.2 and SSSE3
  strcasecmp/strncasecmp

* Sat Oct 12 2013 tmb <tmb> 6:2.18-5.mga4
+ Revision: 496066
- rebuild with new binutils & make

* Fri Oct 11 2013 tmb <tmb> 6:2.18-4.mga4
+ Revision: 495280
- allow building wit GNU Make 4
- (struct __dirstream): Fix alignment of directory block (broken by CVE-2013-4237 fix)

* Sun Oct 06 2013 tmb <tmb> 6:2.18-3.mga4
+ Revision: 492209
- initialize the pointer guard used for pointer mangling (CVE-2013-4788)

* Wed Sep 25 2013 tmb <tmb> 6:2.18-2.mga4
+ Revision: 486293
- inet: avoid redefinition of some structs in kernel

* Tue Sep 17 2013 tmb <tmb> 6:2.18-1.mga4
+ Revision: 480803
- malloc: check for integer overflows in pvalloc, valloc, memalign (CVE-2013-4332)
- make silent builds so only warnings and errors gets logged
- Correct the processing of '\x80' characters in crypt_freesec.c
- fix typo in nscd.service

* Sun Aug 25 2013 tmb <tmb> 6:2.18-0.5.mga4
+ Revision: 471565
- temporarily disable build_check as it eats i686 libs on i586 build
- remove more references to pt_chown
- enable lock elision support
- fix strcoll() integer overflow leading to buffer overflow (CVE-2012-4412),
  and alloca() stack overflow in the strcoll() interface (CVE-2012-4424)
  (fedora, P102)
- install a sanitized LinuxThreads <bits/libc-lock.h> (fedora)
- gcc >= 4.4 is needed to build glibc
- binutils >= 2.20 is needed to build glibc
- experimental-malloc is default since 2011-06-28
- drop obsolete TlsFlags
- fix segfault with __strstr_sse42 (P60)
- Fix cbrtl for ldbl-96 (P100)
- Fix CVE-2013-4237, BZ #14699: Buffer overflow in readdir_r (P101)
- drop minimal required kernel to 2.6.32 so it works in chroots on top
  of enterprise kernels
- pt_chown is disabled/removed as part of fix for CVE-2013-2207
- rediff P17, P38
- drop P18, P60, P61 (merged)
- update to 2.18

* Sun Aug 11 2013 tmb <tmb> 6:2.17-10.mga4
+ Revision: 465392
- rebuild with new gcc

* Thu Aug 01 2013 tmb <tmb> 6:2.17-9.mga4
+ Revision: 462088
- test gcc-4.8.2 build

* Fri Jul 26 2013 colin <colin> 6:2.17-8.mga4
+ Revision: 458507
- Add myhostname to the hosts config in the default nsswitch.conf

* Mon Jun 03 2013 fwang <fwang> 6:2.17-7.mga4
+ Revision: 435858
- rebuild for new libpng

* Mon May 27 2013 oden <oden> 6:2.17-6.mga4
+ Revision: 428749
- rebuilt against libgd.so.3

* Tue Apr 09 2013 tmb <tmb> 6:2.17-5.mga3
+ Revision: 409175
- Fix stack overflow in getaddrinfo with many results (CVE-2013-1914)
- remove duplicate cve patch reference

* Sun Mar 24 2013 colin <colin> 6:2.17-4.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

  + fwang <fwang>
    - fix CVE-2013-0242

  + tmb <tmb>
    - re-enable checks disabled by mistake

* Wed Jan 09 2013 tmb <tmb> 6:2.17-2.mga3
+ Revision: 343961
- fix fhs-usrmove patch that broke util-linux mounting /proc
- fix install of nscd.conf for tempfiles
- fix rest of nscd to use /run directly

  + colin <colin>
    - Ensure tmpfiles is run to create /run/nscd dir on pkg install

  + nanardon <nanardon>
    - revert wrong fix for missing /var/run/nscd
    - provide need /var/run/nscd in nscd package otherwise nscd failed to start

* Tue Jan 01 2013 tmb <tmb> 6:2.17-1.mga3
+ Revision: 337371
- BR libstdc++-static-devel for testsuite
- update to 2.17
- drop upstream release screwup fix
- ports is now merged back with upstream glibc
- adapt P1 (path fixes) according to Mga and UsrMove setup
- rediff P2 (nss upgrade)
- drop P5 (assign global scope to RFC1918 adresses, fixed properly upstream)
- drop P10 (revert pthread_cond_wait change, merged upstream)
- rediff P26: nice priority fix
- rediff P30 (filter out multiarch headers)
- rediff P38 (disable parellel testusite on powerpc)
- rediff P42 (avx owl crypt)
- rediff P39 (freesec crypt support)
- drop P60, P61 (strncasecmp segfault fix, strtod integer buffer overflow
  fix, merged)

  + tv <tv>
    - nsswitch.conf: document all modules

* Mon Oct 15 2012 tmb <tmb> 6:2.16-13.mga3
+ Revision: 306734
- fix and re-enable P43: sha256-crypt and sha512 crypt support (#7793)

* Sat Oct 06 2012 tmb <tmb> 6:2.16-12.mga3
+ Revision: 303047
- require filesystem to get it in same transaction during install

* Wed Oct 03 2012 tmb <tmb> 6:2.16-11.mga3
+ Revision: 302587
- adapt for new dash.static

* Sun Sep 23 2012 tmb <tmb> 6:2.16-10.mga3
+ Revision: 296840
- Fix strtod integer/buffer overflow (P61, upstream BZ 14459)
- Fix segmentation fault in strncasecmp for i686 (P60, upstream)

* Tue Aug 28 2012 tv <tv> 6:2.16-9.mga3
+ Revision: 284978
- rebuild for new binutils

* Sun Aug 05 2012 fwang <fwang> 6:2.16-8.mga3
+ Revision: 278875
- force gb18030 charset for zh_CN locale

* Sat Aug 04 2012 tv <tv> 6:2.16-7.mga3
+ Revision: 278427
- rebuild with compressed debug info

* Thu Aug 02 2012 tv <tv> 6:2.16-6.mga3
+ Revision: 277892
- rebuild with mini debug info

* Sat Jul 28 2012 blino <blino> 6:2.16-5.mga3
+ Revision: 275516
- revert upstream pthread_cond_wait change that cause hangs in pulseaudio

* Sat Jul 28 2012 guillomovitch <guillomovitch> 6:2.16-4.mga3
+ Revision: 275194
- drop sysinit support

  + tmb <tmb>
    - rebuild for kernel 3.5 series

* Mon Jul 23 2012 blino <blino> 6:2.16-3.mga3
+ Revision: 273680
- add a nscd.conf file in tmpfiles.d to create the nscd dir in /var/run (now in tmpfs), from openSUSE

* Fri Jul 20 2012 tmb <tmb> 6:2.16-2.mga3
+ Revision: 272812
- obsolete nss_db as it got merged back in glibc-2.15
- drop old manpages in favour of the newer man-pages rpm
- drop P22 (old kernel bug workaround, already disabled in Mageia 2)
- convert nsswitch.conf patch (P7) to normal source (S8)
- drop obsolete glibc-redhat tarball
- add BR on hardlink as that was the only thing we used from
  the old glibc-redhat tarball

* Wed Jul 18 2012 tmb <tmb> 6:2.16-1.mga3
+ Revision: 272322
- merge glibc-2.16 branch:
  * update to 2.16.0
  * rediff P4, P6, P12, P28, P30, P31, P38, P44
  * drop P49 (rpc change revert) as its replaced by
    '--enable-obsolete-rpc' configure flag
  * drop P48, P60-P62 (merged upstream)
  * disable broken pdf doc build for now
  * update filelists
  * drop obsolete defattr and buildroot from spec

* Wed Jun 27 2012 tmb <tmb> 6:2.14.1-10.mga3
+ Revision: 264229
- rebuild with gcc-4.7.1

* Tue Jun 26 2012 tmb <tmb> 6:2.14.1-9.mga3
+ Revision: 263781
- BR: texinfo-tex
- Upstream fixes needed for upcoming gcc-4.7.1
  * Fix warnings in regex (P60)
  * Fix up regcomp/regexec (P61)
  * Fix regex incomplete multi-byte character (P62)

* Sat Apr 28 2012 tmb <tmb> 6:2.14.1-8.mga2
+ Revision: 233821
- nscd: Require rpm-helper >= 0.24.8-1 for systemd support

* Tue Apr 03 2012 colin <colin> 6:2.14.1-7.mga2
+ Revision: 227986
- Fix PIDFile location in nscd systemd unit.

* Mon Apr 02 2012 guillomovitch <guillomovitch> 6:2.14.1-6.mga2
+ Revision: 227855
- add systemd support for nscd

* Sat Mar 03 2012 tmb <tmb> 6:2.14.1-5.mga2
+ Revision: 217216
- rebuild with new gcc
- linux-userspace-headers is now kernel-userspace-headers

* Tue Dec 27 2011 anssi <anssi> 6:2.14.1-4.mga2
+ Revision: 188165
- use rpm-mageia-setup's new $EXCLUDE_FROM_FULL_STRIP to only strip
  debug symbols from ld.so, libpthread.so, libc.so instead of using
  EXCLUDE_FROM_STRIP and manual stripping with -g (from Mandriva)
  o fixes missing debug symbols in glibc-debug for libc.so and
    libpthread.so
  o fixes completely missing stripping of ld.so (it will now be
    stripped of debugging symbols only, to avoid issues with gdb)

* Mon Dec 05 2011 tmb <tmb> 6:2.14.1-3.mga2
+ Revision: 176926
- rebuild with new gcc-4.6.2 and binutils-2.22

  + rtp <rtp>
    - Fix crypt blowfish build failure on arm

* Mon Oct 24 2011 dmorgan <dmorgan> 6:2.14.1-2.mga2
+ Revision: 157664
- revert sunrpc removal ( P49)

* Fri Oct 21 2011 tmb <tmb> 6:2.14.1-1.mga2
+ Revision: 157233
- push to /release

* Thu Oct 20 2011 tmb <tmb> 6:2.14.1-0.4.mga2
+ Revision: 156969
- fix segfault at dl lookup (glibc bz #12871)
- fix glibc-ports setup
- drop P47 (already merged in glibc-ports-2.14.1)

* Tue Oct 18 2011 tmb <tmb> 6:2.14.1-0.2.mga2
+ Revision: 156310
- update filelists
- rediff P40, P41
- disable P22 (old tcsetattr kernel bug workaround)
- update crypt_freesec, add urls (pok, mdv)
- update crypt_blowfish to 1.2
- rediff P47 to apply cleanly
- set minimum/required kernel to 2.6.33
- drop ia64, ppc(64), sparc(64) support
- BR texlive
- drop merged patches, rediff P44
- update to 2.14.1

  + tv <tv>
    - make the huge doc subpackages be noarch

  + rtp <rtp>
    - remove native pt_chown when generating cross glibc for non-biarch/mips* case
      too
    - fix cross_program_prefix
    - move gnuext macro for build_cross case after isarch definition
    - doesn't create a ld.so.cache in build_cross case

* Tue Mar 22 2011 rtp <rtp> 6:2.12.1-11.mga1
+ Revision: 75374
- Add support for glibc-ports
- Add arm support
- Add early mips support
- Attempt to fix cross glibc generation

* Thu Feb 24 2011 misc <misc> 6:2.12.1-10.mga1
+ Revision: 58741
- rebuilt for removing various Conflicts and Obsoletes
- remove timezone links that are already present in upstream glibc
- do not hardcode our distro name
- clean old Obsoletes
- remove various Conflicts that are no longer relevant ( like on kernel 2.0.. )
- remove old conflict on rpm < 4.2.2 that date back to 5 years ago

* Mon Jan 10 2011 dmorgan <dmorgan> 6:2.12.1-9.mga1
+ Revision: 5255
- Rediff glibc-2.3.6-nsswitch.conf.patch

  + blino <blino>
    - add back wrongly removed endif
    - remove old comment
    - remove old ldconfig scriptlets

  + tmb <tmb>
    - imported package glibc


* Thu Jan 06 2011 Thomas Backlund <tmb@mageia.org> 6:2.12.1-9.mga1
- initial import
- drop rpm tags
- drop mandriva specific changes

* Mon Dec 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-8mnb2
+ Revision: 625383
- Fix _PATH_VI for Mandriva also in sysdeps/unix/sysv/linux/paths.h
  (MDV #60929).

* Tue Nov 23 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-7mnb2
+ Revision: 600264
- Include getlogin_r fixes from glibc head (MDV #61145).

* Sun Oct 24 2010 Oden Eriksson <oeriksson@mandriva.com> 6:2.12.1-6mnb2
+ Revision: 587863
- P45: security fix for CVE-2010-3856 (redhat)

* Wed Oct 20 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-5mnb2
+ Revision: 586990
- Add fix for CVE-2010-3847
  (http://sourceware.org/ml/libc-hacker/2010-10/msg00007.html)

* Sat Oct 16 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-4mnb2
+ Revision: 585932
- Add patch from Andreas Schwab, posted on libc-hacker, that fixes
  another make 3.82 issue in glibc, detected by tst-xmmymm failure
  (http://sources.redhat.com/ml/libc-hacker/2010-09/msg00001.html)

* Wed Sep 29 2010 Anssi Hannula <anssi@mandriva.org> 6:2.12.1-3mnb2
+ Revision: 582103
- fix regression of ldconfig -r when /var/cache/ldconfig does not exist
  inside the chroot and running as non-root (as used by e.g. icecream)
  (upstream bug #11149, patch by Petr Baudis)

* Tue Sep 28 2010 Anssi Hannula <anssi@mandriva.org> 6:2.12.1-2mnb2
+ Revision: 581834
- fix build of locales package by adding transliteration for U20A1
  (COLON SIGN) (patch by Aurelien Jarno from Debian tree as spotted by
  Thomas Backlund)

* Fri Aug 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.12.1-0.1mnb2
+ Revision: 573446
- Updated to version 2.12.1
- Fix build with make 3.82
- Rediffed assign-global-scope-to-RFC-1918-addresses patch
- Include nss config file template for /etc/default in documentation
- Dropped merged/obsolete patches:
  glibc-2.11-Prevent-silent-errors-should-x86-64-strncmp-be-neede.patch
  glibc-2.11-Avoid-ELF-lookup-race.patch
  glibc-2.11-Fix-malloc_info-without-prioor-allocations.patch
  glibc-2.11-Pass-sysdep-LDFLAGS-when-using-print-file-name.patch
  glibc-2.11-_nl_load_locale-incorrectly-handles-mmap-failures.patch
  glibc-2.11-sysdeps-ieee754-ldbl-128-fixes.patch
  glibc-2.11-Don-t-map-U00DF-to-U1E9E-in-toupper-table.patch
  glibc-2.11-check-fd-arg-in-futimens.patch
  glibc-2.11-Add-nonnull-attribute-to-unsetenv-declaration.patch
  glibc-2.11-Additional-setcontext-etc.-conformance-tests.patch
  glibc-2.11-Make-unistd.h-pre-c-safe.patch
  glibc-2.6.1-CVE-2010-0296.diff
  glibc-2.11-Remove-unnecessary-returns.patch
  glibc-2.11-Always-use-IPv4-sockets-for-IPv4-addresses.patch
  glibc-2.11-Fix-error-checking-in-iconv.patch
  glibc-2.11-Redefine-O_SYNC-and-O_DSYNC-to-match-2.6.33-kernels.patch
  glibc-2.11-regcomp.c-do-not-ignore-memory-allocation-failure.patch
  glibc-2.6.1-CVE-2010-0015.diff
  glibc-2.11-Use-struct-timespec-for-timestamps-in-struct-stat-al.patch
  glibc-2.11-Remove-duplicate-definitions-of-O_DSYNC-and-O_RSYNC.patch
  glibc-2.11-Fix-typo-in-feature-selection-macro-use.patch
  glibc-2.11-Fix-file-descriotor-leak-in-nftw-with-FTW_CHDIR.patch
  glibc-2.11-Try-harder-to-re-exec-nscd-in-paranoia-mode.patch
  glibc-2.11-assign-global-scope-to-RFC-1918-addresses.patch
  glibc-2.11-Fix-a-few-more-cases-of-ignored-return-values-in-reg.patch
  glibc-2.11-Fix-endless-loop-with-invalid-etc-shells-file.patch
  glibc-2.11-Follow-kernel-F_OWNER_-GID-PGRP-change.patch
  glibc-2.11-Define-IPTOS_CLASS_-macros-according-to-RFC-2474.patch
  glibc-2.11-Use-correct-type-when-casting-d_tag.patch
  glibc-2.11-Invalid-timeouts-in-i386-sem_timedwait.patch
  glibc-2.11-more-re-fixes.patch
  glibc-2.11-Define-SCHED_IDLE-and-SCHED_RESET_ON_FORK-for-Linux.patch
  glibc-2.11-Fix-sorting-of-malayalam-letter-na.patch
  glibc-2.11-Update-constants-for-current-kernels.patch
  glibc-2.11-Ignore-negative-dynamic-entry-types.patch
  glibc-2.11-Avoid-alloca-in-setenv-for-long-strings.patch
  glibc-2.11-Update-poll.h-header-for-POSIX-2008.patch

* Tue Jun 08 2010 Oden Eriksson <oeriksson@mandriva.com> 6:2.11.1-8mnb2
+ Revision: 547264
- P95: security fix for CVE-2010-0015
- P96: security fix for CVE-2010-0296

* Mon May 31 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-7mnb2
+ Revision: 546806
- Fix permission of /usr/share/doc/glibc-devel/crypt_blowfish-1.0.2/*
  files (#59585).

* Fri May 14 2010 Eugeni Dodonov <eugeni@mandriva.com> 6:2.11.1-6mnb2
+ Revision: 544813
- Bump release.

  + Herton Ronaldo Krzesinski <herton@mandriva.com.br>
    - Revert removal of exclusion list to avoid stripping of some of glibc
      libraries and loader (#59247).
    - Removal of more unwanted patch backup files shipped in created packages.

* Tue Apr 27 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-4mnb2
+ Revision: 539689
- Rebuild with rpm-mandriva-setup-build >= 1.104, with fixed stripping
  of shared libraries (reported/requested by Christophe Fergeau).

* Mon Apr 19 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-3mnb2
+ Revision: 536772
- Assign global scope to RFC 1918 addresses in getaddrinfo (MDV #58834).

* Thu Apr 08 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-2mnb2
+ Revision: 533159
- Fix localedef --add-to-archive with locales which have symlinked
  common files to optimize disk space usage.

* Wed Mar 31 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11.1-1mnb2
+ Revision: 530536
- Updated to glibc 2.11.1, dropped merged patches:
  glibc-2.11-restore-locking-in-free_check.patch
  glibc-2.11-Add-missing-Linux-MADV_-definitions.patch
  glibc-2.11-Fix-getwc-and-putwc-on-non-wide-streams.patch
  glibc-2.11-Avoid-warnings-in-CPU_-macros-when-using-const-bitsets.patch
  glibc-2.11-Fix-startup-to-security-relevant-static-binaries.patch
  glibc-2.11-Fix-F_SETOWN_EX-and-F_GETOWN_EX-definitions.patch
  glibc-2.11-Fix-spelling-in-memusagestat.c.patch
  glibc-2.11-Fix-week-information-for-nl_NL-locale.patch
  glibc-2.11-Properly-handle-STT_GNU_IFUNC-symbols-in-do_sym.patch
  glibc-2.11-Prevent-unintended-file-desriptor-leak-in-grantpt.patch
  glibc-2.11-Handle-running-out-of-buffer-space-with-IPv6-mapping.patch
  glibc-2.11-Fixes-for-bz10968-bz10969.patch
  glibc-2.11-Reinitialize-_create_xid-state-after-fork.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-en_DK.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-hsb_DE.patch
  glibc-2.10.1-fix-preadv-pwritev-fallocate-__off_t.patch
  glibc-2.11-Fix-ranges-with-multibyte-characters-as-endpoints.patch
  glibc-2.11-Fix-infloop-in-__pthread_disable_asynccancel-on-x86_64.patch

* Fri Mar 05 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 6:2.11-2mnb2
+ Revision: 514736
- fix #57754 at the source in rpm-mandriva-setup-build & spec-helper in stead
- don't strip away symbols needed for ie. valgrind (fixes #57754)

  + Herton Ronaldo Krzesinski <herton@mandriva.com.br>
    - Apply fixes/additions from glibc git master in glibc 2.11 for
      following upstream tickets: bz11126, bz11120, bz11200, bz10992,
      bz11115, bz11194, bz11141, bz11127, bz11271, bz11242, bz11027,
      bz11183, bz11184, bz11185, bz11186, bz11187, bz11188, bz11189,
      bz11190, bz11191, bz11192, bz11193, bz10414, bz11235, bz11093.
    - Apply following fixes from glibc git master:
      * Avoid ELF lookup race
      * Pass $(sysdep-LDFLAGS) when using --print-file-name
      * sysdeps/ieee754/ldbl-128/ fixes
      * Don't map U00DF to U1E9E in toupper table
      * Add nonnull attribute to unsetenv declaration
      * Make unistd.h pre-c99-safe
      * Fix error checking in iconv
      * Redefine O_SYNC and O_DSYNC to match 2.6.33+ kernels
      * Remove duplicate definitions of O_DSYNC and O_RSYNC for Linux/sparc
      * Fix typo in feature selection macro use
      * Fix a few more cases of ignored return values in regex
      * Use correct type when casting d_tag
      * Invalid timeouts in i386 sem_timedwait
      * Simplify test in re_string_skip_chars
      * Ignore negative dynamic entry types
      * Avoid alloca in setenv for long strings

* Thu Dec 03 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.11-1mnb2
+ Revision: 472873
- Added conflicts for old prelink versions that brakes the system with
  glibc 2.11
- Added fix for bz10851, patch from upstream bugzilla.
- Apply upstream fixes/testcases after glibc 2.11, consisting in the
  following patches:
  glibc-2.11-Properly-handle-STT_GNU_IFUNC-symbols-in-do_sym.patch
  glibc-2.11-Fix-spelling-in-memusagestat.c.patch
  glibc-2.11-Handle-running-out-of-buffer-space-with-IPv6-mapping.patch
  glibc-2.11-Fix-F_SETOWN_EX-and-F_GETOWN_EX-definitions.patch
  glibc-2.11-Add-missing-Linux-MADV_-definitions.patch
  glibc-2.11-Fixes-for-bz10968-bz10969.patch
  glibc-2.11-Fix-ranges-with-multibyte-characters-as-endpoints.patch
  glibc-2.11-Follow-kernel-F_OWNER_-GID-PGRP-change.patch
  glibc-2.11-Avoid-warnings-in-CPU_-macros-when-using-const-bitsets.patch
  glibc-2.11-Fix-getwc-and-putwc-on-non-wide-streams.patch
  glibc-2.11-Reinitialize-_create_xid-state-after-fork.patch
  glibc-2.11-Fix-week-information-for-nl_NL-locale.patch
  glibc-2.11-Try-harder-to-re-exec-nscd-in-paranoia-mode.patch
  glibc-2.11-Use-struct-timespec-for-timestamps-in-struct-stat-al.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-en_DK.patch
  glibc-2.11-Define-week-first_weekday-and-first_workday-for-hsb_DE.patch
  glibc-2.11-Fix-startup-to-security-relevant-static-binaries.patch
  glibc-2.11-Prevent-unintended-file-desriptor-leak-in-grantpt.patch
  glibc-2.11-Fix-infloop-in-__pthread_disable_asynccancel-on-x86_64.patch
  glibc-2.11-Define-SCHED_IDLE-and-SCHED_RESET_ON_FORK-for-Linux.patch
- Enable experimental-malloc, and replace mdv51545 patch by "Restore
  locking in free_check" upstream fix.
- Enable multi-arch for i686 and x86_64.
- Enable verbose build for checking.
- Do not build with -U_FORTIFY_SOURCE
- kernel-headers was renamed to linux-userspace-headers, update
  BuildRequires/Requires.
- Use /usr/libexec as libexec directory.
- Add BuildRequires for libcap-devel
- Updated to 2.11
  * dropped merged patches:
    glibc-2.10-branch.patch
    glibc-2.10.1-branch-revert-fix-permission-slave-dev-on-devpts.patch
  * dropped libidn tarballs, libidn is now included in main glibc 2.11
  * provide againt pt_chown after grantpt/pt_chown changes in 2.11, also
    allow libcap to be used without selinux.

* Tue Nov 17 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-8mnb2
+ Revision: 467050
- Ship SUPPORTED localedata file with glibc-i18ndata

* Mon Nov 09 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-7mnb2
+ Revision: 463354
- Apply "Fix preadv, pwritev and fallocate for -D_FILE_OFFSET_BITS=64"
  change from glibc upstream.

* Fri Oct 09 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-6mnb2
+ Revision: 456468
- glibc-manpages.tar.bz2: remove tzselect man page, it's outdated, newer
  versions are provided by man-pages* packages (#20326).

  + Pascal Terjan <pterjan@mandriva.org>
    - Fix service name for mysql (Guillaume Rousse)

* Fri Jul 31 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-5mnb2
+ Revision: 405246
- Mandriva does not ship pt_chown with glibc, not supporting system
  without devpts. After glibc 2.10.1 we will must ship it again with
  suid because of grantpt changes upstream, but for now just revert the
  grantpt commit cherry pick from upstream changes with bug fixes in
  glibc-2.10-branch.patch (patch with pull from Petr Baudis repository
  at git://repo.or.cz/glibc/pb-stable.git glibc-2.10-branch).
- Updated glibc-2.10-branch.patch, and drop i386-futex-typo patch merged
  at it.

* Thu Jun 25 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 6:2.10.1-4mnb2
+ Revision: 389221
- add a versioned buildrequires on spec-helper just to be on the safe side :)
- with the mystery of the missing debug symbols solved in spec-helper 0.30.5,
  rebuild to really solve this one (closes #51374)

* Tue Jun 23 2009 Pascal Terjan <pterjan@mandriva.org> 6:2.10.1-3mnb2
+ Revision: 388677
- Rebuild to hopefuly get -debug

* Thu Jun 11 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-2mnb2
+ Revision: 385040
- Fixed free_check locking issue (#51545).
- Fixed typo in i386 version of LOAD_FUTEX_WAIT_ABS macro.
- Updated glibc 2.10.1 branch patch (glibc-2.10-branch.patch).

* Wed May 27 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.10.1-1mnb2
+ Revision: 380201
- Updated to version 2.10.1
- Dropped merged patches:
  glibc-2.9-bz7067.patch
  glibc-2.9-bz9741.patch
  glibc-2.9-fedora_upstream_fixes.patch
  glibc-2.9-expm1-error.patch
  glibc-2.9-bz6545.patch
  glibc-2.9-bz9750.patch
  glibc-2.9-bz9694.patch
  glibc-2.9-en_GB-first-week-work-day.patch
  glibc-2.9-newer-link-scripts-insert-_begin.patch
  glibc-2.9-SHM_EXEC.patch
  glibc-2.9-dup2_avoid_access_through_PLT.patch
  glibc-2.9-bz7056.patch
  glibc-2.9-_nss_dns_gethostbyaddr2_r-buffer-aligment.patch
  glibc-2.9-bug-hsearch1.patch
  glibc-2.9-bz7040.patch
- Include patch with pull from "git://repo.or.cz/glibc/pb-stable.git
  glibc-2.10-branch", glibc 2.10.1 branch provided by Petr Baudis from
  Suse (http://sources.redhat.com/ml/libc-alpha/2009-05/msg00117.html)
- Rediffed patches: mdv-avx-owl-crypt, mdv-owl-crypt_freesec, multiarch,
  biarch-cpp-defines
- Drop glibc-2.9-dns-no-gethostbyname4.patch, newer glibc has handling
  now to workaround IPv4-IPv6 parallel lookup problems with broken DNS
  servers.

* Mon Apr 06 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.5mnb2
+ Revision: 364483
- Fix first_weekday/first_workday for en_GB locale (#49506).

* Mon Apr 06 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.4mnb2
+ Revision: 364480
- Conflict with fileutils < 4.3.5 to avoid problems when upgrading
  (#49589).

* Thu Mar 26 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.3mnb2
+ Revision: 361466
- Added fixes from glibc cvs for:
  * upstream glibc bz7056 (closes also mdv bug #49142).
  * build issue with binutils 2.19.51.0.2, reference:
    http://sourceware.org/bugzilla/show_bug.cgi?id=9843

* Fri Feb 06 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.2mnb2
+ Revision: 338006
- Add fixes from glibc cvs that deals with following upstream tickets:
  bz7067, bz9741, bz6545, bz9750, bz9694, bz7040. Also another
  miscellaneous fixes included (patches expm1-error, SHM_EXEC,
  _nss_dns_gethostbyaddr2_r-buffer-aligment bug-hsearch1).
- Avoid backup file created with patch glibc-2.9-fedora_upstream_fixes.patch to
  end up in glibc-i18ndata package.

* Mon Jan 19 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.9-0.20081113.1mnb2
+ Revision: 331180
- Additional fix on top of fedora_upstream_fixes added from glibc cvs to
  avoid local plt check error (make check).
- Removed some uneeded old patches.
- Update glibc to version 2.9 (20081113).
- Unfuzz following patches:
  glibc-2.9-ldd-non-exec.patch
  glibc-2.9-share-locale.patch
  glibc-2.2.5-nscd-no-host-cache.patch
  glibc-2.7-mdv-owl-crypt_freesec.patch
  glibc-2.3.5-avx-relocate_fcrypt.patch
- Remove uneeded patch glibc-2.1.95-string2-pointer-arith.patch, there is no
  need to force cast to char * for point arithmetic, as explicitely the gcc
  extension for void * pointer arithmetic is being used.
- Removed patches already applied:
  glibc-2.3.2-config-amd64-alias.patch
  glibc-nscd_fixes.patch
  glibc-2.8-tst-iconv-fixes.patch
- Apply 'hot fixes' from fedora/upstream and workaround for glibc bz7060

* Fri Aug 29 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1.20080520.5mnb2
+ Revision: 277480
- Handle properly upgrades from ld.so.conf with relative ld.so.conf.d
  include path after previous commit.

  + Helio Chissini de Castro <helio@mandriva.com>
    - Lack of relative path on ld.so.conf is breaking usage of ldconfig -r. Reviewed by Herton

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - handle libraries in non-standard locations with ld.so.conf config in /etc/ld.so.conf.d/
    - fix file trigger filter match for lib64

* Wed Jul 02 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1.20080520.4mnb2
+ Revision: 230820
- Add more should start entries for nscd init service, reported by
  Guillaume Rousse (#41055).
- Added more upstream nscd fixes.
- Add upstream change that replaces
  glibc-2.8-bug-iconv6_tst-iconv7-localedata.patch (one of bug-iconv6
  and tst-iconv7 fixes). I didn't saw that there were already a change
  that fixed the same issue.

  + Vincent Danen <vdanen@mandriva.com>
    - properly use conditionals for build_i18ndata and build_timezone so recent rpm doesn't complain
    - update the wrapper_handle_sha patch to fully handle sha256c and sha512c; this makes sha256c viable with passwd (although sha512c still needs some work)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Thu Jun 05 2008 Pixel <pixel@mandriva.com> 6:2.8-1.20080520.3mnb2
+ Revision: 215279
- add rpm filetrigger running "ldconfig -X" when rpm install/remove libraries
- drop patch5 since ldconfig is now nicely handled using rpm filetrigger

* Mon May 26 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1.20080520.2mnb2
+ Revision: 211410
- Add bug-iconv6 and tst-iconv7 fixes from glibc cvs. Even with them
  tests would fail: localedata isn't processed before iconvdata, so
  de_DE.UTF-8 isn't available for the tests. Probably this wasn't
  catched as this problem is masked if de_DE.UTF-8 is already installed
  on main system. Made a patch to make iconvdata depend on localedata.
- nscd init service should start ldap service if present (mdv bug
  41055).
- Remove patches not needed anymore for glibc tests related to gcc 4.2
- Cleanup mdkversion uses from spec: there is no reason for backporting
  or using current package on older distro releases.
- Use different numbering scheme in package release for this glibc 2.8
  "stable-snapshot" release, discussed on Cooker mailing list (asked by
  Anssi Hannula, Thierry Vignaud).
- Remove uneeded README.upgrade.urpmi message since addition of Provides
  to "should-restart = system".
- Rediffed ENOTTY-fr-translation patch.

* Wed May 21 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.8-1mnb2
+ Revision: 209635
- Disable temporarily make check for x86_64.
- Update to glibc 2.8 (no official tarball, generated one from
  glibc-2_8-branch glibc cvs branch).
- Drop glibc cvs patches already applied.
- Merge glibc-2.3.4-nscd-fixes.patch and glibc-2.6-nscd_HUP.patch into
  glibc-nscd_fixes.patch and added more updates/fixes from RedHat.
- Removed update for perl 5.10 (mtrace-perl-5.10.0 patch), already
  applied.

* Tue May 06 2008 Vincent Danen <vdanen@mandriva.com> 6:2.7-13mnb2
+ Revision: 201765
- bump release
- imported crypt-blowfish support from Annvix (2.6.1-8123avx):
  - added crypt-blowfish 1.0.2
  - added crypt_freesec.[ch] source files
  - crypt_freesec.patch which addes support for extended/new-style/BSDI hashes in crypt(3)
  - relocate_fcrypt.patch relocates the fcrypt definition from crypt-entry.c to crypt_blowfish's wrapper.c to enable gcc4 builds
  - increase_BF_FRAME.pach increases the BF_FRAME and BF_CLEAN values
  - crypt.patch is the crypt_blowfish patch for glibc 2.4 (rediffed from the crypt_blowfish package)
  - packages provide glibc-crypt_blowfish
- rediffed crypt.patch
- rediffed crypt_freesec.patch
- added wrapper_handle_sha.patch to add sha256-crypt and sha512-crypt support to the Openwall wrapper.c file, otherwise sha(256|512)-crypt support won't work

* Thu Mar 20 2008 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> 6:2.7-12mnb1
+ Revision: 189119
- use %%_real_vendor macro instead of mandriva as rpmscripts directory name.

* Wed Mar 12 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-11mnb1
+ Revision: 187259
- Disable again make check failure for i[3456]8: failure happens on
  build system but not locally here, and 32 bits on x86_64 fails too
  because missing 32 libs (fixable later with BuildRequires etc.).
- Revert again change that causes java programs use too much memory on
  x86_64 (#38830).
- Workaround test-double failure on x86 with gcc 4.2, found out by
  Makoto Dei (#38794). Also reenable make check failure for i[3456]8.

* Mon Mar 10 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-10mnb1
+ Revision: 183209
- Added cacheinfo update for Intel Tolapai and fix for bz5541 from glibc
  cvs.

  + Anssi Hannula <anssi@mandriva.org>
    - add comments regarding _(provides|requires)_exceptions

* Tue Mar 04 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-9mnb1
+ Revision: 178439
- Provides should be used for previous change (not Suggests), reported
  by Anssi Hannula.

* Mon Mar 03 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-8mnb1
+ Revision: 178073
- Added "Suggests: should-restart = system" to main glibc package,
  proposed by Frederic Crozat (see "RFC: add support in packages for
  notifying user about system reboot needed (or service restart needed)"
  message on cooker ML).

* Wed Feb 27 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-7mnb1
+ Revision: 175818
- Require dash-static instead of dash, because dash requires glibc and
  introduces dependency problems (reported by Pascal Rigaux - pixel).

* Tue Feb 26 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-6mnb1
+ Revision: 175412
- Added fixes from glibc cvs: bz5465, fix-tzh_version-check,
  i486-memmove-with-fortify-fix, x86_64-memset-add-missing-sfence,
  bz5439, bz5441, bz5346.

  + Pixel <pixel@mandriva.com>
    - replace %%mkrel with %%manbo_mkrel for Manbo Core 1

* Sun Feb 10 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-5mdv2008.1
+ Revision: 164745
- Rebuild glibc with kernel-headers-2.6.24-2mdv2008.1

* Fri Feb 08 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-4mdv2008.1
+ Revision: 164302
- Removed kernel-headers, now provided by a standalone package.

* Fri Feb 08 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-3mdv2008.1
+ Revision: 164149
- Prepare to remove kernel-headers from glibc-devel package (removed
  provides, obsoletes and header files, to be able to insert separated
  kernel-headers package on distro).

* Fri Feb 01 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-2mdv2008.1
+ Revision: 161195
- Added patch to avoid $* deprecated warning when using perl 5.10.0 with
  mtrace.
- Updated kernel-headers to version 2.6.24.1mdv
- Added manual fixes from glibc cvs (glibc-2.7-manual_update.patch).
  Removed glibc-2.6-texi_buildpdf_fix.patch, as this obsoletes it.
- Added fixes for bz5222 and bz5600 from glibc cvs.

* Fri Jan 04 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.7-1mdv2008.1
+ Revision: 144915
- Updated to version 2.7
- Updated kernel-headers to version 2.6.24-0.rc6.3mdv
- Removed glibc-2.4.90-powerpc-no-clock_gettime-vdso.patch, seems to be
  not needed anymore.
- Added patch from upstream cvs to fix i586 build
  (glibc-2.7-memcpy_chk_i586.patch).
- Removed already applied patches in glibc 2.7:
  glibc-2.5-ldconfig-old-cache.diff
  glibc-cvs-nscd_dont_cache_ttl0.patch
  glibc-cvs-utimensat.patch
  glibc-bz4599.patch
  glibc-bz4125.patch
  glibc-cvs-gcc_init_fini.patch
  glibc-bz4647.patch
  glibc-bz4773.patch
  glibc-_nl_explode_name_segfault_fix.patch
  glibc-bz4776.patch
  glibc-bz4775.patch
  glibc-cvs-popen_bug_fix.patch
  glibc-bz4792.patch
  glibc-cvs-_cs_posix_v6_width_restricted_envs.patch
  glibc-bz4813.patch
  glibc-bz4812.patch
  glibc-bz4772.patch
  glibc-cvs-warning_patrol_fixes.patch
  glibc-cvs-getconf_add_missing_lvl4_cache_linesize.patch
  glibc-cvs-libc_texinfo_update.patch
  glibc-cvs-ix86_rwlock_fixes.patch
  glibc-cvs-gettext_memleak_fixes.patch
  glibc-cvs-strtod_handle_minuszero.patch
  glibc-cvs-ar_SA-dz_BT-LC_TIME-fixes.patch
  glibc-cvs-po_updates.patch
  glibc-cvs-rh250492.patch
- Removed already applied kernel-headers-dvb-video-fix-includes.patch in
  kernel headers.
- Fix test-ldouble with gcc 4.2 on x86. test-double still fails though,
  so disable make check failure for i[3456]8; it passes on x86_64, not
  sure if it's related to gcc 4.2, will need a better check later and
  someone that knows better about complex math.
- Rebuild with new lzma to fix permissions of man pages (#36176).

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Oct 31 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-5mdv2008.1
+ Revision: 104208
- gconv-modules.cache is volatile (always changed by iconvconfig on
  post), mark it as ghost in rpm files section, so it's ignored in rpm
  -V output.
- Fix installation of lib{memusage,pcprofile}.so files (#35178). Don't
  move them around anymore and hack xtrace/memusage, just use upstream
  defaults avoiding troubles like this in the future.

* Thu Sep 27 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-4mdv2008.0
+ Revision: 93205
- Revert pl_PL LC_TIME changes from glibc 2.6, it's causing problems for
  polish users, see http://qa.mandriva.com/show_bug.cgi?id=34134

* Fri Aug 31 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-3mdv2008.0
+ Revision: 76895
- Rebuild for fixed package changelog.

* Mon Aug 27 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-2mdv2008.0
+ Revision: 72022
- Added ldconfig cache speed up patch (added upstream, reported by
  Pascal Rigaux).
- Make package own ld.so.cache.
- Added pt_BR-i18nfixes patch, minor translation fixes for
  pt_BR, see patch for credits.
- Provide gai.conf sample.

  + Thierry Vignaud <tv@mandriva.org>
    - buildrequires obsoletes buildprereq

* Wed Aug 08 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6.1-1mdv2008.0
+ Revision: 60011
- Updated to version 2.6.1 (technically with previously added patches we
  were already there, this is more a cosmetic change).
- Removed patches already applied in 2.6.1: x86_64-memcpy_cacheinfo,
  epoll, nscd_get_mapping_crash_fix, sparc_build_fix,
  provide_CFI_for_the_outermost_function (reverted apply),
  i386_sync_file_range, bz4745, branch_misc_fixes, malloc,
  x86_64_dummy_files_prevent_stub, bz4512, bz4514,
  ld_hwcap_mask_handling_fix, bz4858, pthread_getattr_np_fix,
  tst_shm_fstat64, ldbl128ibm_fixes, bz4702.
- Added the following upstream fixes: rh250492, strtod_handle_minuszero,
  libc_texinfo_update, ar_SA-dz_BT-LC_TIME-fixes, po_updates,
  gettext_memleak_fixes, ix86_rwlock_fixes.
- Updated warning_patrol_fixes patch with more fixes.
- Really enable libidn addon.

* Mon Aug 06 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-6mdv2008.0
+ Revision: 59528
- Added patch texi_buildpdf_fix, to fix build when build_pdf_doc is
  enabled (parse error fixes for texi2dvi).
- Re-enabled glibc-doc-pdf again (it was fixed in tetex 3.0-23mdk), from
  Giuseppe Ghib?\195?\178 <ghibo@mandriva.com>.

  + Anssi Hannula <anssi@mandriva.org>
    - Really apply kernel-headers-dvb-video-fix-includes.patch.

* Thu Aug 02 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-5mdv2008.0
+ Revision: 58194
- Updated kernel-headers to version 2.6.22.3mdv. The only change inside
  it is to add pci_ids.h file, needed by ldetect as reported by Thierry
  Vignaud.

* Mon Jul 30 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-4mdv2008.0
+ Revision: 56752
- Fixed missing header on popen_bug_fix patch.
- Added one more fix that went upstream related to
  _nl_explode_name_segfault_fix patch.
- Updated nscd_HUP patch from fedora.
- Added more fixes/additions that went upstream: bz4813, bz4772,
  warning_patrol_fixes, sparc_build_fix, bz4812, bz4792, bz4858,
  _cs_posix_v6_width_restricted_envs,
  getconf_add_missing_lvl4_cache_linesize.

* Wed Jul 25 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-3mdv2008.0
+ Revision: 55382
- As reported and found out by Anssi Hannula, revert the following
  upstream change:
  2006-11-30  Jan Kratochvil  <jan.kratochvil@redhat.com>
  	* sysdeps/unix/sysv/linux/i386/clone.S: Provide CFI for the
  	* outermost
  	`clone' function to ensure proper unwinding stop of gdb.
  	* sysdeps/unix/sysv/linux/x86_64/clone.S: Likewise.
  It is causing memory leaks with gcj 4.3 on some cases on x86_64, and
  probably other problems, may be because of a binutils bug.
- Added fix for a popen bug from glibc cvs.

* Fri Jul 20 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 6:2.6-2mdv2008.0
+ Revision: 53918
- Added patch from Anssi Hannula to fix a kernel header issue
  (kernel-headers-dvb-video-fix-includes.patch).
- Added missing fixes to ldbl128ibm_fixes patch.
- Removed hunk from kernel-headers-gnu-extensions.patch that patched
  linux/byteorder/swab.h, as code changed and isn't needed anymore (no
  need now for __extension__ as code no more uses "({ ... })" gcc
  extension).
- Updated kernel-headers to version 2.6.22.1mdv.
- Replaced init_tls_calls with more complete branch_misc_fixes patch,
  that includes it along with more fixes from upstream glibc 2.6 branch.
- Added upstream fix bz4775.
- Don't use echo on post, instead use README.upgrade.urpmi because of
  rpmdrake, as reported by Anssi Hannula. Also use better warning
  message.
- Removed glibc-post-upgrade, dont't restart all services on update
  (#21730). Only re-exec init and sshd if possible/needed.

  + Ademar de Souza Reis Jr <ademar@mandriva.com.br>
    - remove unecessary 'xset fp=[...]' from %%post, since xfs is not
      used anymore (besides, it was pointing to the wrong location)

* Fri Jul 13 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.6-1mdv2008.0
+ Revision: 51838
- Only allow make check to fail if current running kernel version is
  known to work.
- Added more fixes from Jakub Jelinek (upstream):
  _nl_explode_name_segfault_fix, bz4776.
- Deal with LD_LIBRARY_PATH bug when building package between major
  glibc versions.
- Added upstream fixes: nscd_get_mapping_crash_fix, bz4599,
  gcc_init_fini, i386_sync_file_range, init_tls_calls, bz4745, bz4647,
  x86_64_dummy_files_prevent_stub, ld_hwcap_mask_handling_fix,
  bz4773, pthread_getattr_np_fix, tst_shm_fstat64, ldbl128ibm_fixes,
  bz4125, bz4702, nscd_dont_cache_ttl0, utimensat, bz4586.
- Replaced amd64-string patch with x86_64-memcpy_cacheinfo that went
  upstream.
- Replaced futex-waiters with bz4512 patch (only test cases added).
- Replaced printf diff with glibc-bz4514.patch.
- Use new gcc 4.2 -mtune=generic flags for BuildFlags on x86/x86_64.
- Updated kernel headers (2.6.21.2mdv). Because of this removed/modified
  the following patches:
  * avx-kernel-headers-audit_support: already applied.
  * kernel-headers-include-2.6.17.1mdk, syscall-mem-clobbers: obsolete,
    not needed anymore.
  * gnu-extensions: modified, one hunk is not applying anymore as the
    file it patches is gone.
  This new kernel headers use the new scheme of sanitized upstream
  kernel headers, the tarball is generated from make
  headers_install_all.
- Updated create_asm_headers.sh script for new kernel headers.
- Added upstream/redhat patches printf, malloc, futex-waiters, epoll.
  Fix bugs/incompatibility issues in glibc 2.6 (the diffs are from
  suse).
- Updated to version 2.6.
- Redid patches that were not applying anymore: nscd_HUP, nice_fix,
  multiarch, new-charsets.
- Drop patches already applied: hwcap-check-platform, brazil-daylight,
  slovenia-euro, unicode5, all bz* patches, powerpc-ldbl-fixes,
  powerpc-hwcaps, fix-nptl-testcases, powerpc-regdump,
  ttyname-dont-use-isatty, fix-ppc32-setcontext,
  fix-pthread_mutex_timedlock.
- Disabled amd64 patches new-libm, amd64-fix-ceil, amd64-string: don't
  apply anymore, are not approved upstream yet, no updated version.

  + Andreas Hasenack <andreas@mandriva.com>
    - added audit patch, from Vdanen, so we can build audit

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - merge ldconfig package with glibc package
    - replace file dependency /sbin/install-info with package dependency info-install
    - s/mandrake/mandriva/
    - do not build and install localedata for $ALT_ARCH too (fixes #27214)
    - drop libnldbl_nonshared.a from sparc64 (fixes #30589)
    - fix reckless usage of s/.bz2// that broke patch names

  + Pixel <pixel@mandriva.com>
    - explicit file provide /sbin/ldconfig


* Wed Mar 07 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-8mdv2007.1
+ Revision: 134573
- split timezone package off glibc
- fix pthread_mutex_timedlock() on x86_64
- fix setcontext on ppc32
- fix floor() and ceil() inlines on i386 (BZ#3451)
- fix cross-compilation and packaging

* Thu Jan 18 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 6:2.4-7mdv2007.1
+ Revision: 110379
- add Unicode 5.0 support (Pablo)
- use Euro in Slovenia
- enable DT_GNU_HASH support only for MDK >= 2007.1
- explicitly optimize for Cell on powerpc

* Fri Jan 12 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 6:2.4-6mdv2007.1
+ Revision: 108082
- backport DT_GNU_HASH support
- sparc64 updates (Peroyvind)
- fix lsb T.ttyname_r (Stew, glibc head)

* Tue Oct 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-5mdv
- update Brazil tzdata (andreas, #26570)
- update powerpc-cpu add-on to 0.03
- reintroduce dl-cache AT_PLATFORM check from glibc 2.2.5
- really don't use -frename-registers (workaround rpmb bug)
- add selected fixes from 2.5-branch:
  * fix ppc{32,64} libSegFault.so register dump
  * fix 2 NPTL testcases
  * fix ppc{32,64} longjmp (BZ#3225)
  * use AT_PLATFORM and limit the number of important hwcaps on ppc
  * fix ppc{32,64} lrintl/lroundl
  * fix lrint on ppc32 (BZ#3155)
  * fix lrint, llrint (BZ#2592)
  * fix pthread_create() called from cancellation handlers (BZ#3124)
  * fix pthread_cond_{,timed}wait() cancellation (BZ#3123)
  * fix invalid free in error(3) (BZ#2998)
  * fix printing of hexadecimal floating point numbers (BZ#2908)
  * fix too large key check in pthread_setspecific (BZ#2892)
  * fix pthread_join() in already cancelled thread (BZ#2843)
  * fix UINT8_C and UINT16_C definitions in <stdint.h> (BZ#2841)
  * fix mktime() on 32-bit platforms for dates > 2038 (BZ#2821)
  * fix uninitialized len for alloca in ld.so $ORIGIN/$PLATFORM handling (BZ#2792)
  * fix malloc(0xFFFFnnnn) corruption from 32-bit wraparound (BZ#2775)
  * fix insque() to conform to POSIX (BZ#2766)
  * fix envz_strip() (BZ#2703)
  * fix dladdr() with SHN_UNDEF symbols (BZ#2683)
  * provide getlogin prototype even for -D_XOPEN_SOURCE=500 (BZ#2680)
  * fix cacosh() (BZ#2182)

* Mon Jul 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-4mdk
- update kernel headers to 2.6.17
- --enable-kernel=2.6.12 on powerpc arches
- add powerpc-cpu add-on and optimize for power5 and power6
- install generic <bits/stdio-lock.h> header (RH #162634)
- cleanups (use new %%isarch)
- sparc changes from Per Oyvind Karlsen
- buildrequires: texinfo (Christiaan Welvaart)
- build glibc-post-wrapper against newly installed libs (Christiaan)

* Mon May 22 2006 Arnaud Patard <apatard@mandriva.com> 2.4-3mdk
- update kernel-headers to the 2.6.16-2mdk to be able to build applications
  that are including linux/input.h

* Fri May 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-2mdk
- update new-charsets patch
- update kernel-headers to 2.6.16
- update x86_64 strings library from AMD

* Thu May 11 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.4-1mdk
- update to glibc 2.4 + CVS (2006/05/11) minus 2.5-specific bits
- drop linuxthreads for now, nptl is the default
- update x86_64 math library from AMD

* Mon Mar 20 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.6-3mdk
- refactor nsswitch.conf
- fix ENOTTY fr translation (noticed by Rafael)
- fix build on sparc32 (Per Oyvind, from Debian)
- fix nftw with root directory and FTW_CHDIR (#9121)
- fix dlopen() memory leaks (#21691, BZ #2451, from CVS HEAD)

* Mon Feb 20 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.6-2mdk
- all tests pass on ppc64
- fix localedef for complex LC_COLLATE rules (BZ #368, HEAD)
- make -mno-tls-direct-seg-refs the default for x86 Xen arches
- don't ship ppc64 asm headers for ppc32 builds
- don't provide ld-linux.so.2 on ppc (Christiaan Welvaart)

* Thu Feb 16 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.6-1mdk
- 2.3.6
- kernel-headers fixes (ppc64, ethtool.h, rsbac_syscall4)
- use dedicated macros to handle nscd service (FredL)
- fix permissions for */lib/*.so
- fix glibc-devel deps (#19145)
- fix upgrades from conectiva, aka conflicts glibc-base <= 2.3.4 (#19256)

* Wed Oct 19 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-6mdk
- support kernel 2.6 series only on ppc64
- add missing ppc64 asm headers for newer kernels

* Mon Aug 29 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-5mdk
- update to 2.6.12-11mdk kernel headers
- make glibc-utils scripts biarch capable
- ship with localised libc.mo files again
- ship with 32-bit profile libs on biarch platforms
- move Xen optimized libraries to their own subpackage
- check for /lib* prior to writing the upgrade stamp (G. Niemeyer)
- fix BZ #1188 (Sergio Gelato, mountd crash)

* Sat Aug 06 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-4mdk
- enable fortify with our gcc4
- fix amd64 string routines (latest snapshot from SuSE)
- provide nptl libraries suitable when running under Xen
- drop build support with distcc, icecream is used instead
- run testsuite with _NPROCESSORS_ONLN jobs at most (i.e. local run)

* Tue Aug 02 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-3mdk
- fix requires for shiny new rpm... and its bugs
- update to 2.6.12-8mdk kernel headers
- support only 2.6+ kernel series on ppc64
- minimal NPTL kernel for 2006 is >= 2.6.9, this brings the following:
  * getdents syscall returns d_type information as well
  * ppc adds signal/swapcontext support for VMX instructions & regstate
  * x86 has a fixed version of posix_fadvise64
  * new syscalls: waitid, utimes, tgkill, statfs64
- updates from 2.3-branch (2005/07/21):
  * avoid dynamically sized stack arrays in regex (BZ #1101)
  * fix sign-extension issues in xdr_stdio on 64-bit big endian
    machines + xdr{,_u}_hyper fixes (BZ #1098, #1097)
  * fix ISO-4217 spec for sr_CS locale, aka add CSD currency (BZ #549)
  * correctly account for characters of decimal points right after +-,
    aka scanf fixes (BZ #1110)
  * fix recursive dlclose (BZ #1081)
  * add %%z format to strptime (BZ #1105)
  * fix age calculation in nscd cache pruning (BZ #1094)
  * fix segfault in regexec (BZ #934)
  * fix posix_fallocate semantics using ftruncate (BZ #1083)
  * fix BZs #1099, #1108, #1100, #1103, #1095, #1101, #779, #1087,

* Wed Jun 15 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-2mdk
- generate gconv-modules.cache
- requires and post scripts tweaks
- add optimized AMD64 strings library
- fix tst-cancel17 with newer kernels (CVS HEAD)

* Fri Jun 03 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.3.5-1mdk
- factor out test matrix
- build 32-bit tls libs on x86_64
- build tls libraries on sparc64 (Stefan)
- remove -fno-unit-at-a-time from build flags
- fix aliasing in AMD64 new libm
- updates from 2.3-branch (2005/04/27):
  * update from Intel ia64 libm 2005-03-21
  * fix BZs #253, #776, #821, #822, #825, #851, #877

* Wed Mar 16 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-8mdk
- fix initstate_r (#14591)

* Thu Mar 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-7mdk
- fix package url (MDK #14468, Zeb)
- update to 2.6.11-2mdk kernel headers (inotify 0.20)
- update to stable 2.3-branch (2005/03/01):
  * fix BZs #284, #671, #719, #722, #726, #727, #729, #730, #731,
      * fix segfault in open_path, aka fix rsync --daemon (BZ #738)
  * fix powerpc64 set/swap context (BZ #700)
  * support -mno-tls-direct-seg-refs builds (BZ #737)
  * update to tz{code,data}2005c (BZ #736)
  * do not allocate potentially large buffers on the stack
  * futimes() should not fail with ENOENT (BZ #633)
  * declare ftruncate for POSIX 2003 (BZ #640)
  * fix rint on powerpc (BZ #602)
  * update ia64 libm (BZ #592)
  * fix round() to round return value to nearest (BZ #626)
  * fix {,q}ecvt{,_r} on denormals (BZ #725)
  * fix i386 stack alignment in clone and linuxthreads (BZ #723)

* Wed Feb 23 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-6mdk
- fix fdim() in x86_64 libm, use glibc implementation
- really stick with getconf files in /usr/lib/getconf
- update kernel headers to 2.6.10-3mdk for new inotify
- kernel header fixes (cdp, fddi)

* Thu Feb 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-5mdk
- kernel headers fixes (christiaan/ppc, directfb/x86_64, usbutils/any)

* Thu Jan 27 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-4mdk
- add missing getconf files
- always propagate pgoff_t definition (workaround kernel header)

* Mon Jan 24 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-3mdk
- relax __le64 and __be64 definitions in kernel headers

* Fri Jan 21 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-2mdk
- update to 2.6.10 kernel headers
- add memory clobbers in asm-i386 syscalls as arguments may be
  pointers to modifiable memory and values need to be reloaded
  (e.g. _llseek() in util-linux)

* Tue Dec 28 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.4-1mdk
- 2.3.4
- fix kernel headers (videodev2.h, blkpg.h on ppc64)
- bring "compat" only to nsswitch.conf
- cosmetics to make check machinery

* Thu Nov 25 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-23mdk
- fix cross bootstrap builds
- enable biarch support on ppc64
- enable tls and nptl on ia64 and ppc64

* Fri Oct 08 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-22mdk
- revert nsswitch.conf change
- fix <linux/ijxuser.h> on non x86 platforms
- reread /etc/localtime even if just mtime has changed (CVS)

* Thu Sep 16 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-21mdk
- add pcc to nptl arches
- fix path to nscd socket
- bring "compat" mode to nsswitch.conf
- fix kernel headers for usbutils rebuild

* Thu Sep 02 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-20mdk
- add ppc to tls arches (Christiaan Welvaart)
- selected fixes from CVS (2004/09/01):
  * fix locking issues in nscd
  * fix some IPv6 related bugs

* Wed Aug 25 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-19mdk
- fix nice
- fix nscd runlevels
- selected fixes from CVS (2004/08/24):
  * add O_NOATIME to linux <fcntl.h> from 2.6.8+ (BZ #341)
  * fix nis nss_compat's initgroups handling
  * fix possible problem with ld.so and brk management (BZ #227)

* Wed Aug 18 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-18mdk
- add missing glibc compat symlinks
- add sparc to TLS arches (Per Oyvind)
- fix <linux/capi.h> standalone inclusion

* Tue Aug 17 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-17mdk
- enable AMD optimized libm for x86_64
- add pow10 and friends in x86_64 libm

* Fri Aug 13 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-16mdk
- some minor build arrangements
- add compat glibc 2.0 for some ancient programs

* Fri Aug 13 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-15mdk
- fix <linux/crc-ccitt.h>
- update from CVS (2004/08/12):
  * fix BZ #150, #198, #217, #218, #219, #230, #231, #232, #262, #263
  * fix pthread_rwlock_timedrdlock on x86_64
  * fix values for -m32 -D_FILE_OFFSET_BITS=64 on x86_64
  * fix psignal() changes from previous CVS syncs
  * fix backtrace in statically linked programs on ia64/x86-64/s390{,x}
  * fix possible buffer overflow in crypt()
  * fix lowmem handling in chroot_canon() (BZ #199)
  * handle more than 6 args correctly on x86_64 makecontext()

* Wed Aug 11 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-14mdk
- update to 2.6.8 kernel headers (fix #10693)
- selected fixes from CVS:
  * make inet_pton() RFC2133 (BZ #295)
  * fix strtold() on 32-bit arches with ldbl-96 (BZ #274)
  * fix pow{,f,l}() on IA-32 and powl() on AMD64 (BZ #258)

* Mon Jul 05 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-13mdk
- fix upgrades for /etc/ld.so.conf.d/*
- update to 2.3.4 CVS snapshot (2004/06/01)
- update to 2.6.6+ kernel headers, I want POSIX message queues
- update patch to handle multiple types of libraries from one ld.so

* Tue May 25 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-12mdk
- Make ldconfig handle "include ld.so.conf.d/*.conf" (2.3.4-cvs)

* Thu Apr 15 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.3.3-11mdk
- Enable use of kernel timers for NPTL timer_create()
- Fix mathinline.h again
- alpha & sparc64 updates (Stefan)
- Merge from AMD64 branch:
  * Fix rwlocks on AMD64 with NPTL
  * Various fixes to kernel-headers
  * Really fix build on AMD64 with 2.4 kernel

